SystemOrganization addCategory: #'SeasideAsync-Platform'!
SystemOrganization addCategory: #'SeasideAsync-Tests'!
SystemOrganization addCategory: #'SeasideAsync-Rendering'!
SystemOrganization addCategory: #'SeasideAsync-Widgets'!
SystemOrganization addCategory: #'SeasideAsync-Renderers'!
SystemOrganization addCategory: #'SeasideAsync-Libraries'!
SystemOrganization addCategory: #'SeasideAsync-Browser'!

!WAAbstractTextAreaTag methodsFor: '*seasideasync' stamp: 'mb 11/3/2006 17:20'!
liveCallback: liveBlock
	| uri id |
	id := self ensureId.
	liveBlock fixCallbackTemps.
	uri := canvas urlForLiveAction: 
		[:event :h | liveBlock
			value: event value
			value: h].
	self session 
		addLoadScript: 
			'liveSearch('
				, id asString printString
				, ','
				, (canvas encode: uri asString) printString
				, ')'.! !

WAHtmlStreamDocument subclass: #WAXmlStreamDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Rendering'!

!WAXmlStreamDocument classSide methodsFor: 'instance creation' stamp: 'mb 3/30/2006 12:55'!
new
	^ self root: self newRoot! !

!WAXmlStreamDocument classSide methodsFor: 'instance creation' stamp: 'mb 3/30/2006 12:54'!
newRoot
	^ self rootClass new! !

!WAXmlStreamDocument classSide methodsFor: 'instance creation' stamp: 'mb 3/30/2006 12:52'!
rootClass
	^WAXmlRoot! !

!WAXmlStreamDocument methodsFor: 'public' stamp: 'mb 11/14/2006 22:22'!
close
	self writeLoadScripts.
	self bodyStream nextPutAll: '</body>'.! !

!WAXmlStreamDocument methodsFor: 'public' stamp: 'mb 8/16/2006 14:38'!
writeLoadScripts
	| session attributes |
	session := WACurrentSession value.
	(session isNil or: [ session onLoadScripts isEmpty ])
		ifTrue: [ ^ self ].
	attributes := WAHtmlAttributes new.
	attributes at: 'type' put: 'text/javascript'.
	self openTag: 'script' attributes: attributes.
	session onLoadScripts
		do: [ :each | self text: each displayString ]
		separatedBy: [ self text: ';' ].
	self closeTag: 'script'.
	session clearLoadScripts! !

WARenderCanvas subclass: #WAAsyncRenderCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Renderers'!

!WAAsyncRenderCanvas methodsFor: 'form-elements' stamp: 'mb 11/3/2006 11:43'!
dateInput
	^ self brush: WALiveDateInput new! !

!WAAsyncRenderCanvas methodsFor: 'xml' stamp: 'mb 11/9/2006 07:32'!
spaceEntity
	^'&#160;'! !

!WAAsyncRenderCanvas methodsFor: 'form-elements' stamp: 'mb 11/3/2006 11:43'!
timeInput
	^ self brush: WALiveTimeInput new! !

!WAAsyncRenderCanvas methodsFor: 'private' stamp: 'mb 11/3/2006 18:01'!
urlForLiveAction: actionBlock 
	| url |
	url := context actionUrl withParameter: (self callbacks registerLiveActionCallback: actionBlock renderer: self).
	^url asString! !

WADecoration subclass: #WAClassBrowserDialogDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

!WAClassBrowserDialogDecoration methodsFor: 'rendering' stamp: 'mb 11/6/2006 11:50'!
renderContentOn: html
	self renderOwnerOn: html! !

!WAClassBrowserDialogDecoration methodsFor: 'rendering' stamp: 'mb 11/6/2006 12:13'!
style
	^'
div#lightbox {
	background-color: #edfced;
	border: 1px solid #e8a400;
	padding: 2em;
	width: 50%;
	font-family: Verdana;
}
div#lightbox h3 {
	font-weight: normal;
	font-size: 80%;
}
'! !

!WAClassBrowserDialogDecoration methodsFor: 'rendering' stamp: 'mb 11/6/2006 12:06'!
updateRoot: anHtmlRoot
	| save |	
	(self session application libraries includes: SULibrary) ifFalse:
		["Naughty, dirty, awful hack to make sure SULibrary javascripts are all inserted at the beginning"
		save := OrderedCollection new.
		[anHtmlRoot scripts isEmpty] whileFalse: [save add: anHtmlRoot scripts removeFirst].
		SULibrary updateRoot: anHtmlRoot.
		anHtmlRoot scripts addAll: save].
	super updateRoot: anHtmlRoot.! !

!WACheckboxTag methodsFor: '*seasideasync' stamp: 'mb 11/3/2006 17:20'!
liveCallback: liveBlock
	| uri id |
	id := self ensureId.
	liveBlock fixCallbackTemps.
	uri := canvas urlForLiveAction: 
		[:event :h | liveBlock 
			value: event valueAsBoolean
			value: h].
	self session 
		addLoadScript: 
			'document.getElementById('
				, id asString printString
				, ').onclick = liveCheck(' 
				, id asString printString
				, ','
				, (canvas encode: uri asString) printString
				, ')'
! !

!WASelectTag methodsFor: '*seasideasync' stamp: 'mb 11/3/2006 17:22'!
liveCallback: liveBlock
	| uri id |
	id := self ensureId.
	liveBlock fixCallbackTemps.
	uri := canvas urlForLiveAction:
		[:event :h | liveBlock
			value: (list at: event value asInteger + 1 ifAbsent: [])
			value: h].
	self session 
		addLoadScript: 
			'document.getElementById('
				, id asString printString
				, ').onchange = liveSelect('
				, id asString printString
				, ','
				, (canvas encode: uri asString) printString
				, ')'
! !

WAComponent subclass: #WAAsyncComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Rendering'!

!WAAsyncComponent classSide methodsFor: 'registration' stamp: 'mb 11/3/2006 18:20'!
registerAsApplication: appName
	^(super registerAsApplication: appName)
		addLibrary: WAAsyncScripts;
		yourself
		! !

!WAAsyncComponent classSide methodsFor: 'registration' stamp: 'mb 11/3/2006 18:20'!
registerAsAuthenticatedApplication: appName
	^(super registerAsAuthenticatedApplication: appName)
		addLibrary: WAAsyncScripts;
		yourself
		! !

!WAAsyncComponent methodsFor: 'rendering' stamp: 'mb 11/4/2006 10:26'!
rendererClass
	^WAAsyncHtmlRenderer! !

WAAsyncComponent subclass: #WAAutoCompleteEntryField
	instanceVariableNames: 'callback selectedObject listHeight name listWidth stringsToObjects strings prefix selectedString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Widgets'!

!WAAutoCompleteEntryField commentStamp: '<historical>' prior: 0!
This widget is a contribution from Anthony Lander
(anthony@etherealplanet.org)!

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:45'!
callback: aOneArgumentBlock
	"When a selection is made, aOneArgumentBlock is evaluated with the selected object"

	callback _ aOneArgumentBlock! !

!WAAutoCompleteEntryField methodsFor: 'initialize-release' stamp: 'mb 3/5/2006 22:49'!
initialize

	super initialize.
	stringsToObjects _ Dictionary new.
	strings _ #().
	prefix _ ''.
	selectedString _ nil.
	selectedObject _ nil.
	listHeight _ 5.
	listWidth _ 30.! !

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:45'!
listHeight: numberOfLines
	listHeight _ numberOfLines! !

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:45'!
listWidth: numberOfCharacters
	listWidth _ numberOfCharacters! !

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:48'!
name: aString
	name _ aString! !

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:50'!
numberOfItems
	^stringsToObjects size! !

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:47'!
objects: objects strings: objectLabels

	strings _ objectLabels.
	stringsToObjects _ Dictionary new: objects size.
	objectLabels with: objects
		do: [:label :object | stringsToObjects at: label put: object].
	prefix _ ''.
	selectedString _ nil.
	selectedObject _ nil.! !

!WAAutoCompleteEntryField methodsFor: 'rendering' stamp: 'mb 3/6/2006 00:01'!
renderAutoCompleteSuggestionListOn: html 
	| labelsMatchingPrefix prefixPattern |
	html divNamed: 'D'
		with: 
			[(prefix isEmptyOrNil not and: [selectedString isNil]) 
				ifTrue: 
					[prefixPattern _ prefix asUppercase , '*'.
					labelsMatchingPrefix _ (strings 
								select: [:label | prefixPattern match: label asUppercase]) 
									asSortedCollection asArray.
					labelsMatchingPrefix isEmpty 
						ifTrue: 
							[selectedString _ ''.
							selectedObject _ nil]
						ifFalse: 
							[labelsMatchingPrefix size = 1 
								ifTrue: 
									[prefix _ selectedString _ labelsMatchingPrefix first.
									selectedObject _ stringsToObjects at: selectedString].
							html divClass: 'dropdown'
								with: 
									[html unorderedList: 
											[(labelsMatchingPrefix copyFrom: 1
												to: (labelsMatchingPrefix size min: listHeight)) do: 
														[:label | 
														html listItem: 
																[html 
																	anchorWithAction: []
																	liveAction: 
																		[:h | 
																		selectedString _ prefix _ label.
																		selectedObject _ stringsToObjects at: label.
																		callback value: selectedObject.
																		self renderAutoCompleteTextFieldOn: h]
																	text: label]]]]]]]! !

!WAAutoCompleteEntryField methodsFor: 'rendering' stamp: 'mb 10/31/2006 17:10'!
renderAutoCompleteTextFieldOn: html 
	html
		cssClass: 'autocomplete';
		divNamed: 'autocomplete'
			with: 
				[html
					cssClass: 'label';
					divNamed: 'L' with: name.
				html
					cssClass: 'input';
					divNamed: 'I'
						with: 
							[(html attributes)
								width: listWidth em;
								at: #autocomplete put: 'off'.
							html 
								textInputWithValue: prefix
								callback: 
									[:v | 
									prefix _ v.
									callback value: selectedObject.
									html bold: prefix]
								liveCallback: 
									[:v :h | 
									prefix _ v.
									selectedString _ nil.
									self renderAutoCompleteSuggestionListOn: h].
							self renderAutoCompleteSuggestionListOn: html]]! !

!WAAutoCompleteEntryField methodsFor: 'rendering' stamp: 'mb 3/5/2006 22:42'!
renderContentOn: html 
	self numberOfItems > 30
		ifTrue: [self renderAutoCompleteTextFieldOn: html]
		ifFalse: [self renderSimpleDropDownOn: html]! !

!WAAutoCompleteEntryField methodsFor: 'rendering' stamp: 'mb 3/5/2006 22:43'!
renderSimpleDropDownOn: html 
	| objectsToLabels |
	objectsToLabels _ IdentityDictionary new.
	stringsToObjects 
		keysAndValuesDo: [:label :object | objectsToLabels at: object put: label].
	html
		cssClass: 'autocomplete';
		divNamed: 'autocomplete'
			with: 
				[html
					cssClass: 'label';
					divNamed: 'L' with: [html text: name].
				html
					cssClass: 'input';
					divNamed: 'I'
						with: 
							["html attributes size: listWidth."

							html 
								selectFromList: strings
								selected: strings first
								callback: 
									[:l | 
									selectedObject _ stringsToObjects at: l.
									callback value: selectedObject]]]! !

!WAAutoCompleteEntryField methodsFor: 'rendering' stamp: 'mb 11/4/2006 10:26'!
rendererClass
	"Intentionally using the classic API"
	^WAAsyncHtmlRenderer! !

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:48'!
selectedObject
	^selectedObject! !

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:47'!
selectedObject: anObject string: aString
	prefix _ selectedString _ aString.
	selectedObject _ anObject.! !

!WAAutoCompleteEntryField methodsFor: 'css' stamp: 'mb 10/31/2006 17:11'!
style
 	^'
	.autocomplete { width: 50em;  font-family: Tahoma, Arial, Helvetica; font-size: 100%;  }
	.autocomplete .label { width: 10em; float: left; text-align: right; font-weight: bold;  }
	.autocomplete .input { float: left; margin-left: 1em; width: 30em; }

	.dropdown { overflow: hidden; border-width: 1px; border-style: solid; border-color: black; }
	.dropdown ul { list-style-type: none; margin: 0; padding: 0; }
	.dropdown ul li { clear: left; float: left; display: inline; width: 100%; line-height: 1.1em; }
	.dropdown ul li.selected { font-weight: bold; line-height: 1.1em; }

	.dropdown a { display: block; padding: 3px; width: 20em; background-color: #036; border-bottom: 1px solid #eee; }
	.dropdown a:link, .dropdown a:visited { color: #EEE; text-decoration: none; }
	.dropdown a:hover { background-color: #369; color: #fff; }
'! !

WAAsyncComponent subclass: #WAAutoCompleteTest
	instanceVariableNames: 'autocomplete inputValue inputValueComplete selectedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Tests'!

!WAAutoCompleteTest classSide methodsFor: 'class initialization' stamp: 'mb 6/13/2006 18:42'!
initialize
	self registerAsApplication: 'tests/async/classic/autocomplete'! !

!WAAutoCompleteTest methodsFor: 'rendering' stamp: 'mb 3/5/2006 22:51'!
children
	^Array with: autocomplete! !

!WAAutoCompleteTest methodsFor: 'initialize-release' stamp: 'mb 11/14/2006 22:56'!
initialize

	autocomplete := (WAAutoCompleteEntryField new)
		name: 'Choose a class:';
		listHeight: 6;
		yourself! !

!WAAutoCompleteTest methodsFor: 'constants' stamp: 'mb 2/24/2006 14:48'!
namelist
	^#(Andrew Bengt Chuck Daniel Elmer Franz George Henry Isildur) ,
		#(Jefferson Jeffrey Jeremy Jerry John Josuah Kleber Lewis Mike) , 
			#( Nancy Oscar Peter Robert Roger Stephen Steven Tobias Vincent William)! !

!WAAutoCompleteTest methodsFor: 'rendering' stamp: 'mb 3/5/2006 22:54'!
renderAutoCompleteOn: html 
	| selection |
	html divNamed: #autoComplete
		with: 
			[(inputValue isEmptyOrNil not and: [inputValueComplete not]) 
				ifTrue:
					[selection _ self namelist 
								detect: [:ea | (ea copyFrom: 1 to: (inputValue size min: ea size)) asUppercase = inputValue asUppercase]
								ifNone: [nil].
					html attributes size: 3.
					html cssId: #autoCompleteSelect.
					html 
						selectFromList: self namelist
						selected: selection
						callback:
							[:v |
							inputValue _ v.
							inputValueComplete _ true]
						labels: [:ea | ea]
						liveCallback: 
							[:v :h | 
							inputValue _ v.
							inputValueComplete _ true.
							self renderTextFieldOn: h]]].
	html script: 'document.getElementById("autoComplete").style.width = document.getElementById("input").style.width'.
	! !

!WAAutoCompleteTest methodsFor: 'rendering' stamp: 'mb 3/6/2006 15:46'!
renderContentOn: html 
	| classes |


	html heading: 'AutoComplete Test (two different techniques)' level: 3; br.

	html form: [
		html defaultAction: [self inform: inputValue].
		self renderTextFieldOn: html.
		html submitButtonWithText: 'Go'].

	classes _ (Object withAllSubclasses reject: [:e | e class = Metaclass]) asArray.

	autocomplete objects: classes strings: (classes collect: [:e | e name]).
	autocomplete callback: [:class | selectedClass _ class].

	html form: [
		html text: 'You have selected: '; text: (selectedClass isNil ifTrue: ['Nothing'] ifFalse: [selectedClass name]);br;br.
		html render: autocomplete.
		html submitButtonWithAction: [] text: 'Go'].
! !

!WAAutoCompleteTest methodsFor: 'rendering' stamp: 'mb 2/24/2006 17:03'!
renderTextFieldOn: html
	html attributes addStyle: 'width: 15em'. 
	html divNamed: #input
		with: 
			[html cssId: #inputField.
			html 
				textInputWithValue: inputValue
				callback:
					[:v |
					inputValue := v. 
					inputValueComplete := true]
				liveCallback: 
					[:v :h | 
					inputValue := v.
					inputValueComplete := false.
					self renderAutoCompleteOn: h]].
	self renderAutoCompleteOn: html! !

!WAAutoCompleteTest methodsFor: 'rendering' stamp: 'mb 11/4/2006 10:26'!
rendererClass
	"Intentionally using the classic API"
	^WAAsyncHtmlRenderer! !

!WAAutoCompleteTest methodsFor: 'css' stamp: 'mb 3/5/2006 23:19'!
style
	^'
#input input {
	width: 100%;
}
#autoComplete select {
	background-color: lightyellow;
	width: 100%;
}
form {
	width: 60%; 
	border: 1px solid green;
	padding: 5px;
	background-color: lightyellow;
}
'! !

WAAsyncComponent subclass: #WACanvasFocusTest
	instanceVariableNames: 'log cbValue selected radioValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Tests'!

!WACanvasFocusTest classSide methodsFor: 'as yet unclassified' stamp: 'mb 6/13/2006 18:42'!
initialize
	self registerAsApplication: 'tests/async/canvas/focuscapture'.! !

!WACanvasFocusTest methodsFor: 'initialization' stamp: 'mb 11/14/2006 22:56'!
clearLog
	log := OrderedCollection new.
! !

!WACanvasFocusTest methodsFor: 'initialization' stamp: 'mb 11/3/2006 19:02'!
initialize
	self clearLog.
	cbValue := false.
	radioValue := false.! !

!WACanvasFocusTest methodsFor: 'rendering' stamp: 'mb 11/3/2006 19:33'!
renderContentOn: html 
	| group |
	html form
		with:
			[
			html textInput
				onFocusCallback: [:event | log add: 'Entry field' -> event value];
				callback: [:v | ].
			html select
				list: #( a b c );
				onFocusCallback: [:event | log add: 'Select box' -> event value];
				selected: selected.
			html checkbox
				onClickCallback: [:event | log add: 'Checkbox' -> event value];
				value: cbValue;
				callback: [:v | cbValue := v].
			html span
				style: 'border: 1px dashed grey';
				with:
					[group := html radioGroup.
					html radioButton
						group: group;
						onFocusCallback: [:event | log add: 'radio(left)' -> event value]; "Does not work in Safari 2.0.4"
						selected: radioValue;
						callback: [:v | radioValue := false].
					html radioButton
						group: group;
						onFocusCallback: [:event | log add: 'radio(right)' -> event value]; "Does not work in Safari 2.0.4"
						selected: radioValue not;
						callback: [:v | radioValue := true].
					].
			html submitButton].
	log notEmpty ifTrue: [self renderLogOn: html]! !

!WACanvasFocusTest methodsFor: 'rendering' stamp: 'mb 3/31/2006 09:09'!
renderLogOn: html 
	html paragraph: 
		[html
			text: 'Before button was clicked, field with focus was:';
			break;
			bold: log last key;
			break;	
			text: 'At that time the field received the focus, its value was:';
			break;
			bold: log last value].
	html heading: 'Captured events' level: 5.
	log do:
			[:each | html text: each printString]
		separatedBy:
			[html break].
	self clearLog.! !

!WACanvasFocusTest methodsFor: 'rendering' stamp: 'mb 11/4/2006 10:27'!
rendererClass
	^ WAAsyncRenderCanvas! !

WAAsyncComponent subclass: #WACanvasLiveRequestTest
	instanceVariableNames: 'input1 input2 selection count bool country province city date booleans time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Tests'!

!WACanvasLiveRequestTest classSide methodsFor: 'as yet unclassified' stamp: 'mb 10/29/2005 11:39'!
canBeRoot
	^ true! !

!WACanvasLiveRequestTest classSide methodsFor: 'as yet unclassified' stamp: 'mb 6/13/2006 18:43'!
initialize
	self registerAsApplication: 'tests/async/canvas/livetests'.! !

!WACanvasLiveRequestTest methodsFor: 'nested' stamp: 'mb 8/16/2006 14:10'!
city: anObject
	city := anObject.
! !

!WACanvasLiveRequestTest methodsFor: 'nested' stamp: 'mb 11/14/2006 23:01'!
cityNames
	province = 'Oranjestad'
		ifTrue: [^#( 'Casibari' 'Bubali')	].
	province = 'Santa Cruz'
		ifTrue: [^#( 'Arikok' 'Yamonta')	].
	province = 'Buenos Aires'
		ifTrue: [^#('La Plata' 'Azul')].
	province = 'Cordoba'
		ifTrue: [^#('Alta Gracia' 'La Falda')].
	province = 'California'
		ifTrue: [^#('Los Angeles' 'Monterey' 'San Jose' 'Santa Monica')].
	province = 'Ohio'
		ifTrue: [^#('Cincinnati' 'Dayton' 'Clifton')].
	^#()


! !

!WACanvasLiveRequestTest methodsFor: 'nested' stamp: 'mb 8/16/2006 14:11'!
country: anObject
	country := anObject. 
	self province: self provinceNames first. 
! !

!WACanvasLiveRequestTest methodsFor: 'initialization' stamp: 'mb 11/3/2006 17:39'!
initialize
	count := 0.
	bool := false.
	input1 := String new.
	input2 := String new.
	self country: 'Argentina'.
	booleans := Dictionary new
		at: #English put: true;
		at: #Russian put: false;
		at: #Japanese put: false;
		yourself.


! !

!WACanvasLiveRequestTest methodsFor: 'nested' stamp: 'mb 11/14/2006 22:57'!
province: anObject
	province := anObject.
	self city: self cityNames first.

! !

!WACanvasLiveRequestTest methodsFor: 'nested' stamp: 'mb 11/14/2006 22:59'!
provinceNames
	country = 'Aruba'
		ifTrue: [^#('Oranjestad' 'Santa Cruz')].
	country = 'Argentina'
		ifTrue: [^#( 'Buenos Aires' 'Cordoba')].
	country = 'USA'
		ifTrue: [^#( 'Ohio' 'California')].
	^#()


! !

!WACanvasLiveRequestTest methodsFor: 'rendering' stamp: 'mb 1/6/2006 10:42'!
renderAnchorOn: html

	html anchor
		callback: [self error: 'Should not come here'];
		liveCallback:
			[:h | 
			h span id: 'timestamp'; with: TimeStamp now.
			h span id: 'time'; with: Time now];
		text: 'Show time'.
	html space.
	html span id: 'timestamp'; with: ''.
! !

!WACanvasLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/20/2005 16:41'!
renderCheckBoxOn: html

	html form:
		[html checkbox
				value: bool; 
				callback: [:v | bool _ v];
				liveCallback: 
					[:item :h |
					bool _ item.
					"Update multiple areas of the document using one live callback"
					h span id: 'checkbox'; with: (bool ifTrue: ['checked'] ifFalse: ['unchecked']).
					h span id: 'chk'; with: (bool ifTrue: ['checked'] ifFalse: ['unchecked']).
					].
			
		html space.
		html span id: 'chk'; with: (bool ifTrue: ['checked'] ifFalse: ['unchecked']).
		].
	! !

!WACanvasLiveRequestTest methodsFor: 'nested' stamp: 'mb 11/14/2006 22:58'!
renderCitiesOn: html

	html span id: 'citySelector'; with:
		[(html select)
			list: self cityNames;
			selected: city;
			callback:[:f | city := f ];						
			labels: [:ea |  ea ]]		
! !

!WACanvasLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/3/2006 17:58'!
renderContentOn: html

	self renderWarningOn: html.
	html table:
		[html tableRow:
			[html tableData:
				[self renderInput1On: html.
				self renderInput2On: html.
				self renderDateInputOn: html.
				self renderTimeInputOn: html.
				self renderListOn: html.
				self renderCheckBoxOn: html.
				self renderRadioOn: html.
				self renderAnchorOn: html].
			html tableData:
				[html heading: 'Forward' level: 3.
				html div id: 'forward'; with: ''.
				html heading: 'Backward' level: 3.
				html div id: 'backward'; with: ''.
				html heading: 'Date' level: 3.
				html div id: 'date'; with: ''.
				html heading: 'Time' level: 3.
				html div id: 'xtime'; with: ''.
				html heading: 'Selection' level: 3.
				html span id: 'selection'; with: ''.
				html heading: 'Checkbox' level: 3.
				html span id: 'checkbox'; with: ''.
				html heading: 'Radio buttons' level: 3.
				html span id: 'radio'; with: booleans printString.
				html heading: 'Time' level: 3.
				html span id: 'time'; with: ''].
			]
		].
	html heading: 'Nested live callbacks' level: 3.
	self renderCountriesOn: html.


	self renderWarningOn: html.! !

!WACanvasLiveRequestTest methodsFor: 'nested' stamp: 'mb 11/14/2006 22:58'!
renderCountriesOn: html
	(html select)
		list: #( 'Argentina' 'Aruba' 'USA' );
		selected: country;
		callback: [:f | country := f]; 
		labels: [:ea |  ea ];
		liveCallback: 
			[:anObject :h | 
			country := anObject. 
			province := self provinceNames first. 
			city := self cityNames first.
			self renderProvincesOn: h].

	self renderProvincesOn: html.
! !

!WACanvasLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/4/2006 12:14'!
renderDateInputOn: html

	html form:
		[html dateInput
			value: date;
			liveCallback:
					[:value :h |
					date := value.
					h div id: 'date'; with: date.
					h span id: 'dat'; with: 'Value entered= ' , date displayString.
					].
		html space.
		html span id: 'dat'; with: 'Value entered= ' , date displayString.
		].! !

!WACanvasLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/20/2005 16:41'!
renderInput1On: html

	html form:
		[html textInput
				value: input1; 
				callback: [:v | input1 _ v];
				liveCallback: 
					[:text :h |
					input1 _ text. 
					"Update multiple areas of the document using one live callback"
					h div id: 'forward'; with:
						[h unorderedList:
							[input1 do:
								[:c | 
								h listItem:
									[h anchor 
									callback: [self inform: c displayString];
									text: c displayString]]]].
					h span id: 'fwd'; with:
						[h text: 'Value entered= ' , input1.
						h script: 'alert("javascript in a live callback ' , input1 , ' ");']
					].
		html space.
		html span id: 'fwd'; with:'Value entered= ' , input1.
		html break.
		html text: 'Above: Javascript attached= alert("Javascript in a live callback xxx ");'
		].
! !

!WACanvasLiveRequestTest methodsFor: 'rendering' stamp: 'mb 9/8/2006 10:14'!
renderInput2On: html

	html form:
		[html textArea
				value: input2;
				callback: [:v | input2 _ v];
				liveCallback: 
					[:text :h |
					input2 _ text.
					h div id: 'backward'; with: 
						[h unorderedList: 
							[input2 reverse do: 
								[:c |
								h listItem: 
									[h anchor 
										callback: [self inform: c displayString];
										text: c displayString]]]].
					h span id: 'bwd'; with: 'Value entered= ' , input2
					].
		html space.
		html span id: 'bwd'; with: 'Value entered= ' , input2
		].
! !

!WACanvasLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/3/2006 15:01'!
renderListOn: html

	html form:
		[html select 
				list: #(a b c); 
				selected: selection; 
				labels: [:ea | ea displayString];
				liveCallback:
					[:item :h |
					selection _ item. 
					"Update multiple areas of the document using one live callback"
					h span id: 'selection'; with: selection.
					h span id: 'sel'; with: 'Value selected= ' , selection displayString
					].
		html space.
		html span id: 'sel'; with: 'Value selected= ' , selection displayString
		].
! !

!WACanvasLiveRequestTest methodsFor: 'nested' stamp: 'mb 11/14/2006 22:58'!
renderProvincesOn: html

	html span id: 'provinceSelector'; with:
		[(html select)
			list:  self provinceNames;
			selected: province;
			callback: [:f | province := f]; 
			labels: [:ea |  ea ];
			liveCallback: 
				[:anObject :h | 
				province := anObject. 
				city := self cityNames first.
				self renderCitiesOn: h]].
	self renderCitiesOn: html.


! !

!WACanvasLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/3/2006 17:53'!
renderRadioOn: html
	html
		form: [
			html table: [
				html tableRow: [
					html tableData: 'Language'.
					html tableData: 'Yes'.
					html tableData: 'No'].

				booleans associationsDo:
					[:assoc | 
					| group |
					html tableRow: [
						group := html radioGroup.
						html tableData: assoc key.
						html tableData: [
							(html radioButton)
								id: assoc key asString , '-on';
								group: group;
								selected: assoc value;
								liveCallback:
									[:item :h |
									assoc value: true.
									h span id: 'radio'; with: booleans printString]].
						html tableData: [
							(html radioButton)
								id: assoc key asString , '-off';
								group: group;
								selected: assoc value not;
								liveCallback:
									[:item :h |
									assoc value: false.
									h span id: 'radio'; with: booleans printString.]].
					]].
			]]
! !

!WACanvasLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/4/2006 12:14'!
renderTimeInputOn: html

	html form:
		[html timeInput
			value: time;
			liveCallback:
					[:value :h |
					time := value.
					h div id: 'xtime'; with: time.
					h span id: 'tim'; with: 'Value entered= ' , time displayString.
					].
		html space.
		html span id: 'tim'; with: 'Value entered= ' , time displayString.
		].! !

!WACanvasLiveRequestTest methodsFor: 'rendering' stamp: 'mb 1/6/2006 11:38'!
renderWarningOn: html 
	"The #insert: method was not available in 2.6a1"
	(html respondsTo: #insert:) ifFalse:
		[html heading: 'Warning : Canvas rendering is unfinished in this release' level: 2]   ! !

!WACanvasLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/4/2006 10:27'!
rendererClass
	^ WAAsyncRenderCanvas! !

WAAsyncComponent subclass: #WACanvasPeriodicLiveRequestTest
	instanceVariableNames: 'log'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Tests'!

!WACanvasPeriodicLiveRequestTest classSide methodsFor: 'class initialization' stamp: 'mb 6/13/2006 18:43'!
initialize
	self registerAsApplication: 'tests/async/canvas/periodictests'.! !

!WACanvasPeriodicLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/14/2006 23:02'!
renderContentOn: html
	| liveUpdateBlock |
	liveUpdateBlock := [ :event :h |
		h text: Time now printString].

	html table with: [
		html tableRow with: [
			html tableData with: 'Current Time in default div:'.
			html tableData with: [
				" Anonymous div. "
				html div
					refreshWith: liveUpdateBlock every: 3 seconds.
			]
		].
		html tableRow with: [
			html tableData with: 'Current Time in default span:'.
			html tableData with: [		
				" Anonymous span.  "
				html span
					refreshWith: liveUpdateBlock every: 5 seconds.
			]
		].
		html tableRow with: [
			html tableData with: 'Current Time in named div:'.
			html tableData with: [
				" Named div "
				html div
					id: 'livediv';
					refreshWith: liveUpdateBlock every: 1 seconds.
			]
		].
		html tableRow with: [
			html tableData with: 'Current Time in named span:'.
			html tableData with: [
				" Named span "
				html span
					id: 'livespan';
					refreshWith: liveUpdateBlock every: 2 seconds.
			]
		]
	]! !

!WACanvasPeriodicLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/4/2006 10:27'!
rendererClass
	^ WAAsyncRenderCanvas! !

WAAsyncComponent subclass: #WAClassBrowserPane
	instanceVariableNames: 'componentName main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

WAClassBrowserPane subclass: #WAClassBrowserLeftPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

!WAClassBrowserLeftPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:48'!
renderClassesListOn: html 
	(html select)
		size: self listSize;
		id: 'classList';
		selected: self selectedClass;
		list: self classes;
		liveCallback:
			[:value :renderer |
			main selectClass: value on: renderer].
! !

!WAClassBrowserLeftPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:44'!
renderClassesOn: html 
	(html div)
		id: 'classes';
		with: [ self renderClassesListOn: html ]! !

!WAClassBrowserLeftPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:23'!
renderContentOn: html 
	self renderPackagesOn: html.
	self renderClassesOn: html.! !

!WAClassBrowserLeftPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:49'!
renderPackagesListOn: html 
	(html select)
		size: self listSize;
		id: 'packageList';
		selected: self package;
		list: self packages;
		liveCallback:
			[:value :renderer |
			main selectPackage: value on: renderer].
! !

!WAClassBrowserLeftPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:45'!
renderPackagesOn: html 
	(html div)
		id: 'packages';
		with: [ self renderPackagesListOn: html ].! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 18:25'!
canRemoveSourceCode
	^self main canRemoveSourceCode! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/18/2006 14:28'!
canRenameSourceCode
	^self main canRenameSourceCode! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 18:22'!
canSaveSourceCode
	^self main canSaveSourceCode! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:56'!
classes
	^self main classes! !

!WAClassBrowserPane methodsFor: 'accessing' stamp: 'mb 10/13/2006 12:55'!
componentName
	"Answer the value of componentName"

	^ componentName! !

!WAClassBrowserPane methodsFor: 'accessing' stamp: 'mb 10/13/2006 12:55'!
componentName: anObject
	"Set the value of componentName"

	componentName _ anObject! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:56'!
isReadOnly
	^self main isReadOnly! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:56'!
isReadOnly: aBoolean
	^self main isReadOnly: aBoolean! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:57'!
listSize
	^self main listSize! !

!WAClassBrowserPane methodsFor: 'accessing' stamp: 'mb 10/13/2006 12:55'!
main
	"Answer the value of main"

	^ main! !

!WAClassBrowserPane methodsFor: 'accessing' stamp: 'mb 10/13/2006 12:55'!
main: anObject
	"Set the value of main"

	main _ anObject! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:57'!
package
	^self main package! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:57'!
package: anObject
	^self main package: anObject! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:57'!
packages
	^self main packages! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:57'!
pause
	^self main pause! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:58'!
protocol
	^self main protocol! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:58'!
protocol: anObject
	^self main protocol: anObject! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:19'!
protocols
	^self main protocols! !

!WAClassBrowserPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:16'!
rendererClass
	^WAAsyncRenderCanvas! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:20'!
selectedClass
	^self main selectedClass! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:20'!
selectedClass: anObject
	^self main selectedClass: anObject! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:21'!
selector
	^self main selector! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:21'!
selector: anObject
	^self main selector: anObject! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:21'!
selectors
	^self main selectors! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:21'!
sourceCode
	^self main sourceCode! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:21'!
sourceTitle
	^self main sourceTitle! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:21'!
templateSourceCode
	^self main templateSourceCode! !

WAClassBrowserPane subclass: #WAClassBrowserRightPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

!WAClassBrowserRightPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:27'!
renderContentOn: html 
	self renderProtocolsOn: html.
	self renderSelectorsOn: html.! !

!WAClassBrowserRightPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:56'!
renderProtocolsListOn: html 
	(html select)
		size: self listSize;
		id: 'protocolList';
		selected: self protocol;
		list: self protocols;
		liveCallback:
			[:value :renderer |
			main selectProtocol: value on: renderer]! !

!WAClassBrowserRightPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:51'!
renderProtocolsOn: html 
	(html div)
		id: 'protocols';
		with: [ self renderProtocolsListOn: html ].! !

!WAClassBrowserRightPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:56'!
renderSelectorsListOn: html 
	(html select)
		size: self listSize;
		id: 'selectorList';
		selected: self selector;
		list: self selectors;
		liveCallback:
			[:value :renderer |
			main selectSelector: value on: renderer]! !

!WAClassBrowserRightPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:52'!
renderSelectorsOn: html 
	(html div)
		id: 'selectors';
		with: [ self renderSelectorsListOn: html ]! !

WAClassBrowserPane subclass: #WAClassBrowserSourcePane
	instanceVariableNames: 'sourceCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

!WAClassBrowserSourcePane methodsFor: 'button text' stamp: 'mb 10/18/2006 14:22'!
removeButtonText
	^'Remove this ' , self main removeText , ' (Ctrl-X)'! !

!WAClassBrowserSourcePane methodsFor: 'button text' stamp: 'mb 10/18/2006 14:26'!
renameButtonText
	^'Rename this ' , self main renameText , ' (Ctrl-R)'! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:42'!
renderContentOn: html 
	self renderSourceOn: html! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 10/13/2006 16:04'!
renderMessageOn: html 
	main message notNil 
		ifTrue: 
			[(html div)
				id: 'message';
				with: main message]
		ifFalse: 
			[(html div)
				id: 'title';
				with: self sourceTitle]! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 10/13/2006 18:01'!
renderReadOnlySourceOn: html 
	| stream lines |
	lines := OrderedCollection new.
	stream := sourceCode readStream.
	[stream atEnd] whileFalse: [lines add: stream nextLine].
	lines := lines readStream.
	html bold: lines next.
	[lines atEnd] whileFalse: 
			[html break.
			stream := lines next readStream.
			[stream atEnd] whileFalse: 
					[stream peek == Character tab 
						ifTrue: 
							[html space: 3.
							stream next]
						ifFalse: [html text: stream upToEnd]]]! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 10/18/2006 14:19'!
renderRemoveButtonOn: html 
	self canRemoveSourceCode ifTrue:
		[(html submitButton)
			addShortcut: 'Ctrl-X';
			addShortcut: 'Ctrl-x';
			callback: [main removeSourceCode];
			text: self removeButtonText]! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 10/18/2006 14:31'!
renderRenameButtonOn: html 
	self canRenameSourceCode ifTrue:
		[(html submitButton)
			addShortcut: 'Ctrl-R';
			addShortcut: 'Ctrl-r';
			callback: [main renameSourceCode];
			text: self renameButtonText]! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 10/13/2006 18:22'!
renderSaveButtonOn: html 
	self canSaveSourceCode ifTrue:
		[(html submitButton)
			addShortcut: 'Ctrl-S';
			addShortcut: 'Ctrl-s';
			callback: [main saveSourceCode: sourceCode];
			text: 'Accept (Ctrl-S)']! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:42'!
renderSourceCodeOn: html 
	sourceCode := self sourceCode ifNil: [^html space].
	self isReadOnly ifTrue: [^self renderReadOnlySourceOn: html].
	self renderMessageOn: html.
	html form: 
			[(html textArea)
				id: #contents;
				callback: [:v | sourceCode := v];
				value: sourceCode.
			self renderSaveButtonOn: html.
			self renderRenameButtonOn: html.
			self renderRemoveButtonOn: html.]
! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:43'!
renderSourceOn: html 
	(html div)
		id: 'source';
		with: [self renderSourceCodeOn: html]! !

!WAClassBrowserSourcePane methodsFor: 'button text' stamp: 'mb 10/18/2006 14:20'!
saveButtonText
	^'Accept (Ctrl-S)'! !

WAAsyncComponent subclass: #WAFocusTest
	instanceVariableNames: 'log cbValue selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Tests'!

!WAFocusTest classSide methodsFor: 'as yet unclassified' stamp: 'mb 6/13/2006 18:45'!
initialize
	self registerAsApplication: 'tests/async/classic/focuscapture'! !

!WAFocusTest methodsFor: 'actions' stamp: 'mb 11/14/2006 23:02'!
clearLog
	log := OrderedCollection new.! !

!WAFocusTest methodsFor: 'initialization' stamp: 'mb 11/14/2006 23:03'!
initialize
	self clearLog.
	cbValue := false.! !

!WAFocusTest methodsFor: 'rendering' stamp: 'mb 11/14/2006 23:03'!
renderContentOn: html 
	html form: 
			[html onFocusCallback: [:event | log add: 'Entry field' -> event value].
			html textInputWithCallback: [:v | ].
			html onFocusCallback: [:event | log add: 'Select box' -> event value].
			html selectFromList: #( a b c )
				selected: selected
				callback: [:v | selected := v ].
			html onClickCallback: [:event | log add: 'Checkbox' -> event value].
			html checkboxWithValue: cbValue callback: [:v | cbValue := v].
			html submitButton].

	log notEmpty ifTrue: [self renderLogOn: html]! !

!WAFocusTest methodsFor: 'rendering' stamp: 'mb 3/31/2006 09:09'!
renderLogOn: html 
	html paragraph: 
		[html
			text: 'Before button was clicked, field with focus was:';
			break;
			bold: log last key;
			break;	
			text: 'At that time the field received the focus, its value was:';
			break;
			bold: log last value].
	html heading: 'Captured events' level: 5.
	log do:
			[:each | html text: each printString]
		separatedBy:
			[html break].
	self clearLog.! !

!WAFocusTest methodsFor: 'rendering' stamp: 'mb 11/4/2006 10:26'!
rendererClass
	"Intentionally using the classic API"
	^WAAsyncHtmlRenderer! !

WAAsyncComponent subclass: #WAFullClassBrowser
	instanceVariableNames: 'leftComponents left rightComponents right bottom isReadOnly message browser contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

!WAFullClassBrowser classSide methodsFor: 'testing' stamp: 'mb 10/13/2006 12:52'!
canBeRoot
	^true! !

!WAFullClassBrowser classSide methodsFor: 'accessing' stamp: 'mb 11/6/2006 09:01'!
description
	^'Ajax Smalltalk class browser (four panes)'! !

!WAFullClassBrowser classSide methodsFor: 'instance creation' stamp: 'mb 11/6/2006 08:59'!
fullOnClass: aClass
	^self fullOnClass: aClass selector: nil! !

!WAFullClassBrowser classSide methodsFor: 'instance creation' stamp: 'mb 11/6/2006 08:58'!
fullOnClass: aClass selector: aSelector
	^(self new)
		setClass: aClass selector: aSelector;
		yourself! !

!WAFullClassBrowser classSide methodsFor: 'class initialization' stamp: 'mb 11/6/2006 09:00'!
initialize
	self registerAsApplication: 'tools/classbrowser'! !

!WAFullClassBrowser methodsFor: 'browser callbacks' stamp: 'mb 11/6/2006 08:47'!
bindingOf: aString
	"Here when an unknown variable is used in a method"
	(WAUnknownVariable new)
		varName: aString;
		signal! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
bottom
	"Answer the value of bottom"

	^ bottom! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
bottom: anObject
	"Set the value of bottom"

	bottom _ anObject! !

!WAFullClassBrowser methodsFor: 'navigation' stamp: 'mb 10/13/2006 17:18'!
bottomComponent
	^bottom
		main: self;
		yourself! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
browser
	"Answer the value of browser"

	^ browser! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
browser: anObject
	"Set the value of browser"

	browser _ anObject! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 18:42'!
canRemoveSourceCode
	"May remove classes with this tool"
	^self selectedClass notNil.! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/18/2006 16:10'!
canRenameSourceCode
	"May rename a method category"
	^self protocol notNil.! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 18:37'!
canSaveSourceCode
	"Can save new classes with this tool"
	^self package notNil! !

!WAFullClassBrowser methodsFor: 'rendering' stamp: 'mb 10/13/2006 17:20'!
children
	^Array 
		with: self leftComponent
		with: self rightComponent
		with: self bottomComponent! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:09'!
classes
	^self browser classList! !

!WAFullClassBrowser methodsFor: 'lightbox' stamp: 'mb 10/13/2006 19:01'!
confirm: aString
	^self lightbox: (WAYesOrNoDialog new addMessage: aString)! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
contents
	"Answer the value of contents"

	^ contents! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
contents: anObject
	"Set the value of contents"

	contents _ anObject! !

!WAFullClassBrowser methodsFor: 'lightbox' stamp: 'mb 10/13/2006 19:00'!
inform: aString
	self lightbox: (WAFormDialog new addMessage: aString)! !

!WAFullClassBrowser methodsFor: 'initialize-release' stamp: 'mb 11/6/2006 10:09'!
initialRequest: aRequest
	| theClass |
	aRequest fields at: 'class' ifPresent:
		[:className | 
		Smalltalk at: className asSymbol ifPresent:
			[:class |
			theClass := (aRequest fields includesKey: 'meta')
					ifTrue: [class class]
					ifFalse: [class].
			self setClass: theClass selector: nil.
			aRequest fields at: 'method' ifPresent:
				[:selector |
				self setClass: theClass selector: selector asSymbol]]]! !

!WAFullClassBrowser methodsFor: 'initialize-release' stamp: 'mb 11/6/2006 08:55'!
initialize
	super initialize.
	self browser: WAPermissiveBrowser new.
	self browser component: self.
	self browser addDependent: self.
	self contents: self browser contents.
	isReadOnly := false.
	leftComponents := (Dictionary new)
				at: 'Categories' put: WAClassBrowserLeftPane new;
				yourself.
	self left: 'Categories'.
	rightComponents := (Dictionary new)
				at: 'Instance' put: WAClassBrowserRightPane new;
				at: 'Class' put: WAClassBrowserRightPane new;
				yourself.
	self right: 'Instance'.
	bottom := WAClassBrowserSourcePane new.! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
isReadOnly
	"Answer the value of isReadOnly"

	^ isReadOnly! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
isReadOnly: anObject
	"Set the value of isReadOnly"

	isReadOnly _ anObject! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
left
	"Answer the value of left"

	^ left! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
left: anObject
	"Set the value of left"

	left _ anObject! !

!WAFullClassBrowser methodsFor: 'navigation' stamp: 'mb 10/13/2006 18:10'!
leftComponent
	^(leftComponents at: self left)
		main: self;
		componentName: self left;
		yourself! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
leftComponents
	"Answer the value of leftComponents"

	^ leftComponents! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
leftComponents: anObject
	"Set the value of leftComponents"

	leftComponents _ anObject! !

!WAFullClassBrowser methodsFor: 'navigation' stamp: 'mb 10/13/2006 17:18'!
leftOptions
	^leftComponents keys! !

!WAFullClassBrowser methodsFor: 'lightbox' stamp: 'mb 11/6/2006 12:55'!
lightbox: aComponent
	^(self class superclass canUnderstand: #lightbox:) ifTrue:
		[super lightbox: (aComponent addDecoration: WAClassBrowserDialogDecoration new; yourself)]
	ifFalse:
		[self call: aComponent].! !

!WAFullClassBrowser methodsFor: 'constants' stamp: 'mb 10/13/2006 17:08'!
listSize
	^15! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
message
	"Answer the value of message"

	^ message! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
message: anObject
	"Set the value of message"

	message _ anObject! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 11/21/2006 14:30'!
model
	"Polymorphism with WABrowser"
	^self browser! !

!WAFullClassBrowser methodsFor: 'browser callbacks' stamp: 'mb 10/13/2006 17:10'!
notify: aString at: location in: sourceStream
	"Here when there was a compile error"
	message := aString allButLast: 3! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:11'!
package
	self browser systemCategoryListIndex = 0 ifTrue: [^nil].
	^self packages at: self browser systemCategoryListIndex! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:11'!
package: anObject
	^self browser systemCategoryListIndex: (self packages indexOf: anObject)! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:11'!
packages
	^self browser systemCategoryList! !

!WAFullClassBrowser methodsFor: 'private' stamp: 'mb 11/6/2006 09:33'!
pause
	"Activate this code to demo ajax interactivity"
	"(Delay forSeconds: 1) wait."! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:11'!
protocol
	self browser messageCategoryListIndex = 0 ifTrue: [^nil].
	^self protocols at: self browser messageCategoryListIndex! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:11'!
protocol: anObject
	^self browser messageCategoryListIndex: (self protocols indexOf: anObject)! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:12'!
protocols
	^self browser messageCategoryList! !

!WAFullClassBrowser methodsFor: 'actions' stamp: 'mb 10/13/2006 18:44'!
removeSourceCode
	self selector notNil
		ifTrue: [^self browser removeMessage].
	self protocol notNil
		ifTrue: [^self browser removeMessageCategory].
	self selectedClass notNil
		ifTrue: [^self browser removeClass].
! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/18/2006 14:22'!
removeText
	self selector notNil
		ifTrue: [^'method'].
	self protocol notNil
		ifTrue: [^'method category'].
	self selectedClass notNil
		ifTrue: [^'class'].
! !

!WAFullClassBrowser methodsFor: 'actions' stamp: 'mb 10/18/2006 14:32'!
renameSourceCode
	^self browser renameCategory! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/18/2006 14:27'!
renameText
	self protocol notNil
		ifTrue: [^'method category'].
! !

!WAFullClassBrowser methodsFor: 'rendering' stamp: 'mb 10/13/2006 17:23'!
renderContentOn: html
	(html div)
		id: 'class-browser';
		with: 
			[(html div)
				id: 'left';
				with: 
					[(html div)
						class: 'nav-options';
						id: 'left-options';
						with: [self renderLeftOptionsOn: html].
					html render: self leftComponent].
			(html div)
				id: 'right';
				with: 
					[(html div)
						class: 'nav-options';
						id: 'right-options';
						with: [self renderRightOptionsOn: html].
					html render: self rightComponent].	
		html div class: 'clear'.
		html render: self bottomComponent].! !

!WAFullClassBrowser methodsFor: 'rendering' stamp: 'mb 10/13/2006 18:10'!
renderLeftOptionsOn: html 
	(html unorderedList)
		list: self leftOptions;
		selected: self left;
		callback: [:v | self left: v]! !

!WAFullClassBrowser methodsFor: 'rendering' stamp: 'mb 10/13/2006 18:11'!
renderRightOptionsOn: html 
	(html unorderedList)
		list: self rightOptions;
		selected: self right;
		callback: [:v | self right: v]! !

!WAFullClassBrowser methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:16'!
rendererClass
	^WAAsyncRenderCanvas! !

!WAFullClassBrowser methodsFor: 'lightbox' stamp: 'mb 10/13/2006 19:06'!
request: requestString label: labelString default: initialString
	^ self lightbox:
		((WAInputDialog new
			label: labelString;
			default: initialString;
			yourself)
				addMessage: requestString)! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
right
	"Answer the value of right"

	^ right! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 18:11'!
right: anObject
	"Set the value of right"

	right _ anObject.
	self right = 'Class' 
		ifTrue: [self browser indicateClassMessages]
		ifFalse: [self browser indicateInstanceMessages].
! !

!WAFullClassBrowser methodsFor: 'navigation' stamp: 'mb 10/13/2006 18:09'!
rightComponent
	^(rightComponents at: self right)
		main: self;
		componentName: self right;
		yourself! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
rightComponents
	"Answer the value of rightComponents"

	^ rightComponents! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
rightComponents: anObject
	"Set the value of rightComponents"

	rightComponents _ anObject! !

!WAFullClassBrowser methodsFor: 'navigation' stamp: 'mb 10/13/2006 17:18'!
rightOptions
	^rightComponents keys! !

!WAFullClassBrowser methodsFor: 'actions' stamp: 'mb 11/6/2006 08:47'!
saveSourceCode: aString 
	| saveProtocol saveSelector saveMessage |
	SeasidePlatformSupport ensureAuthorInitials: [self request: 'Please enter your initials:'].
	message := nil.
	saveProtocol := self protocol.
	saveSelector := self selector.
	[self browser contents: aString notifying: self]
		on: WAUnknownVariable
		do: [:error | message := error messageText].
	saveMessage := message.
	self protocol: saveProtocol.
	self selector: saveSelector.
	self contents: aString.
	message := saveMessage! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 11/6/2006 09:55'!
selectClass: aClass on: aRenderer
	self selectedClass: aClass.
	self updateProtocolsOn: aRenderer.
! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 11/6/2006 09:47'!
selectPackage: aPackage on: aRenderer
	self package: aPackage.
	self updateClassesOn: aRenderer.
! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 11/6/2006 09:50'!
selectProtocol: aProtocol on: aRenderer
	self protocol: aProtocol.
	self updateSelectorsOn: aRenderer.
! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 11/6/2006 09:53'!
selectSelector: aSelector on: aRenderer
	self selector: aSelector.
	self updateSourceOn: aRenderer.
! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:12'!
selectedClass
	self browser classListIndex = 0 ifTrue: [^nil].
	^self classes at: self browser classListIndex! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:12'!
selectedClass: anObject
	^self browser classListIndex: (self classes indexOf: anObject)! !

!WAFullClassBrowser methodsFor: 'browser callbacks' stamp: 'mb 10/18/2006 15:44'!
selectionInterval
	^1 to: 1! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:13'!
selector
	self browser messageListIndex = 0 ifTrue: [^nil].
	^self selectors at: self browser messageListIndex! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:13'!
selector: anObject
	^self browser messageListIndex: (self selectors indexOf: anObject)! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:39'!
selectors
	self protocol isNil ifTrue: [^Array new].
	^self browser messageList! !

!WAFullClassBrowser methodsFor: 'initialize-release' stamp: 'mb 11/6/2006 10:08'!
setClass: aClass selector: aSymbol
	self browser setClass: aClass selector: aSymbol.! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:13'!
sourceCode
	^self contents! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:57'!
sourceTitle
	self selector notNil 
		ifTrue: [^self selectedClass asString , ' >> ' , self selector].
	self protocol notNil 
		ifTrue: [^self selectedClass asString , ' >> template for new method'].
	self selectedClass notNil 
		ifTrue: [^self selectedClass asString , ' class definition'].
	self package notNil
		ifTrue: [^'Template for new class definition'].
	^nil! !

!WAFullClassBrowser methodsFor: 'rendering' stamp: 'mb 11/19/2006 15:10'!
style
	^ '
div#class-browser {
	font-family: Verdana;
}
div#left, div#right {
	float: left;
	width: 49.9%;
}
div#packages, div#classes, div#protocols, div#selectors {
	float: left;
	width: 49.9%;
}
div.clear {
	clear: both;
	height: 1em;
}
div#packages select, div#classes select, div#protocols select, div#selectors select {
	width: 100%;
}
div#source {
	padding: 1em;
	border: 1px solid #dddddd;
	background-color: #f5f5f5;
}
textarea#contents {
	width: 100%;
	height: 20em;
	margin-top: 1em;
	margin-bottom: 1em;
}
div#message, div#title {
	font-weight: bold;
}
div#message {
	color: red;
}


div.nav-options {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}
div.nav-options ul, div.nav-options li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}
div.nav-options a:link, div.nav-options a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

div.nav-options a:link.active, div.nav-options a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

div.nav-options ul a:hover	{
	color : #f00;
}

div.nav-options .option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}


'! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 18:18'!
text
	^ Text fromString: ''! !

!WAFullClassBrowser methodsFor: 'browser callbacks' stamp: 'mb 10/18/2006 15:20'!
update: aSymbol
	aSymbol == #contents ifTrue:
		["Here when the source pane has changed"
		message := nil.
		self contents: self browser contents]
! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 11/6/2006 09:31'!
updateClassesOn: html 
	self pause.
	self leftComponent renderClassesOn: html.
	self updateProtocolsOn: html.! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 11/6/2006 09:31'!
updateProtocolsOn: html 
	self pause.
	self rightComponent renderProtocolsOn: html.
	self updateSelectorsOn: html.
! !

!WAFullClassBrowser methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:05'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	(self session application libraries includes: WAAsyncScripts) ifFalse:
		[WAAsyncScripts updateRoot: anHtmlRoot].! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 11/6/2006 09:31'!
updateSelectorsOn: html 
	self pause.
	self rightComponent renderSelectorsOn: html.
	self updateSourceOn: html.! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 10/13/2006 17:26'!
updateSourceOn: html 
	self pause.
	self bottomComponent renderSourceOn: html.! !

WAAsyncComponent subclass: #WALiveRequestTest
	instanceVariableNames: 'input1 input2 input3 date selection count bool country province city booleans'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Tests'!

!WALiveRequestTest classSide methodsFor: 'as yet unclassified' stamp: 'mb 10/29/2005 11:39'!
canBeRoot
	^ true! !

!WALiveRequestTest classSide methodsFor: 'as yet unclassified' stamp: 'mb 11/3/2006 18:24'!
initialize
	self registerAsApplication: 'tests/async/classic/livetests'
! !

!WALiveRequestTest methodsFor: 'accessing' stamp: 'mb 10/30/2005 18:46'!
city: anObject
	city := anObject.
! !

!WALiveRequestTest methodsFor: 'accessing' stamp: 'mb 11/14/2006 23:08'!
cityNames
	province = 'Oranjestad'
		ifTrue: [^#( 'Casibari' 'Bubali')	].
	province = 'Santa Cruz'
		ifTrue: [^#( 'Arikok' 'Yamonta')	].
	province = 'Buenos Aires'
		ifTrue: [^#('La Plata' 'Azul')].
	province = 'Cordoba'
		ifTrue: [^#('Alta Gracia' 'La Falda')].
	province = 'Florida'
		ifTrue: [^#('Orlando' 'Miami')].
	province = 'California'
		ifTrue: [^#('Cupertino' 'Santa Barbara' 'Monterey')].
	^#()


! !

!WALiveRequestTest methodsFor: 'accessing' stamp: 'mb 10/30/2005 18:48'!
country: anObject
	country := anObject. 
	self province: self provinceNames first. 
! !

!WALiveRequestTest methodsFor: 'initialization' stamp: 'mb 11/3/2006 16:29'!
initialize
	count := 0.
	bool  := false.
	input1 := String new.
	input2 := String new.
	input3 := 42.
	date := Date today.
	self country: 'Argentina'.
	booleans := Dictionary new
		at: #English put: true;
		at: #Russian put: false;
		at: #Japanese put: false;
		yourself.




! !

!WALiveRequestTest methodsFor: 'accessing' stamp: 'mb 11/14/2006 23:03'!
province: anObject
	province := anObject.
	self city: self cityNames first.

! !

!WALiveRequestTest methodsFor: 'accessing' stamp: 'mb 11/14/2006 23:06'!
provinceNames
	country = 'Aruba'
		ifTrue: [^#('Oranjestad' 'Santa Cruz')].
	country = 'Argentina'
		ifTrue: [^#( 'Buenos Aires' 'Cordoba')].
	country = 'USA'
		ifTrue: [^#( 'California' 'Florida')].
	^#()


! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 3/30/2006 12:48'!
renderAnchorOn: html

	html anchorWithAction: 
				["The live callback disables the regular callback"
				self error: 'Should not come here, please debug me !!']
			liveAction:
				[:h | 
				h spanNamed: 'timestamp' with: TimeStamp now.
				h spanNamed: 'time' with: Time now]
			text: 'Show time'.
	html space.
	html spanNamed: 'timestamp' with: ''.
! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/14/2006 22:01'!
renderCheckBoxOn: html
	
	html form:
		[html checkboxWithValue: bool 
				callback: [:v | bool := v ] 
				liveCallback: 
					[:item :h |
					bool := item.
					"Update multiple areas of the document using one live callback"
					h spanNamed: 'checkbox' with: (bool ifTrue: ['checked'] ifFalse: ['unchecked']).
					h spanNamed: 'chk' with: (bool ifTrue: ['checked'] ifFalse: ['unchecked']).
					].
		html space.
		html spanNamed: 'chk' with: (bool ifTrue: ['checked'] ifFalse: ['unchecked']).
		].
! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/14/2006 23:04'!
renderCitiesOn: html

	html spanNamed: 'citySelector' with:
		[html 
			selectFromList: self cityNames
			selected: city
			callback:[:f | city := f ]						
			labels: [:ea |  ea ]]		
! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/15/2006 09:29'!
renderContentOn: html

	html table: [
		html tableRowWith:
			[self renderInput1On: html.
			self renderInput2On: html.
			self renderInput3On: html.
			self renderDateInputOn: html.
			self renderListOn: html.
			self renderCheckBoxOn: html.
			self renderRadioOn: html.
			self renderAnchorOn: html.

			html break.
			html anchorWithAction: 
						[self error: 'Should not come here'] 
					liveAction: 
						[:h | h spanNamed: 'time' with: 1/0] 
					text: 'Live error'.
			html break; break.
			html scrollbarWithHeight: 100 size: 1000 liveCallback: [:n :h | h spanNamed: 'scroll' with: n]	
			] 
		with: 
			[html heading: 'Forward' level: 3.
			html divNamed: 'forward' with: ''.
			html heading: 'Backward' level: 3.
			html divNamed: 'backward' with: ''.
			html heading: 'Number' level: 3.
			html divNamed: 'number' with: ''.
			html heading: 'Date' level: 3.
			html divNamed: 'date' with: ''.
			html heading: 'Selection' level: 3.
			html spanNamed: 'selection' with: ''.
			html heading: 'Check box' level: 3.
			html spanNamed: 'checkbox' with: (bool ifTrue: ['checked'] ifFalse: ['unchecked']).
			html heading: 'Radio buttons' level: 3.
			html spanNamed: 'radio' with: booleans printString.
			html heading: 'Time' level: 3.
			html spanNamed: 'time' with: ''.
			html heading: 'Scrollbar' level: 3.
			html spanNamed: 'scroll' with: ''.
			]
	].

	html heading: 'Nested live callbacks' level: 3.
	self renderCountriesOn: html.

	self  renderStyle: nil on: html.
	html break.	
	self renderUnproductiveOn: html.
	
! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/14/2006 23:04'!
renderCountriesOn: html 

	html
		selectFromList: #( 'Argentina' 'Aruba' 'USA' )
		selected: country
		callback: [:f | country := f] 
		labels: [:ea |  ea ]
		liveCallback: 
			[:anObject :h | 
			country := anObject. 
			province := self provinceNames first. 
			city := self cityNames first.
			self renderProvincesOn: h].

	self renderProvincesOn: html.
! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/14/2006 23:04'!
renderDateInputOn: html

	html form:
		[html
			dateInputWithValue: date 
			callback: [:value | date := value]
			liveCallback:
					[:value :h |
					date := value.
					h divNamed: 'date' with: date.
					h spanNamed: 'dat' with: 'Value entered= ' , date displayString.
					].
		html space.
		html spanNamed: 'dat' with: 'Value entered= ' , date displayString.
		].! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/14/2006 23:05'!
renderInput1On: html

	html form:
		[html textInputWithValue: input1
				callback: [:v | input1 := v]
				liveCallback:
					[:text :h |
					input1 := text.
					"Update multiple areas of the document using one live callback"
					h divNamed: 'forward' with:
						[h list: input1 do:
							[:c |
							h anchorWithAction: [self inform: c asString] text: c asString]].
					h spanNamed: 'fwd' with:
						[h text: 'Value entered= ' , input1.
						h script: 'alert("Javascript in a live callback ' , input1 , ' ");'].
					].
		html space.
		html spanNamed: 'fwd' with: 'Value entered= ' , input1.
		html break.
		html text: 'Above: Javascript attached= alert("javascript in a live callback xxx ");'.		
		].
! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/14/2006 23:05'!
renderInput2On: html

	html form:
		[html textAreaWithValue: input2 
				callback: [:v | input2 := v]
				liveCallback:
					[:text :h |
					input2 := text.
					"Update multiple areas of the document using one live callback"
					h divNamed: 'backward' with:
						[h list: input2 reverse do:
							[:c |
							h anchorWithAction: [self inform: c asString] text: c asString]].
					h spanNamed: 'bwd' with: 'Value entered= ' , input2.
					].
		html space.
		html spanNamed: 'bwd' with: 'Value entered= ' , input2.
		].
! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/14/2006 23:05'!
renderInput3On: html

	html form:
		[html textInputWithValue: input3 
				callback: [:v | input3 := v]
				liveCallback:
					[:value :h |
					input3 := value.
					"Update multiple areas of the document using one live callback"
					h divNamed: 'number' with: input3.
					h spanNamed: 'nbr' with: 'Value entered= ' , input3 asString.
					].
		html space.
		html spanNamed: 'nbr' with: 'Value entered= ' , input3 asString.
		].! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/14/2006 23:50'!
renderListOn: html

	html form:
		[html selectFromList: #(red blue green) 
				selected: selection 
				callback: [:v | selection := v]
				labels: [:ea | ea asString]
				liveCallback:
					[:item :h |
					selection := item.
					"Update multiple areas of the document using one live callback"
					self renderStyle: selection on: h.
					h spanNamed: 'selection' with: item.
					h spanNamed: 'sel' with: 'Value selected= ' , selection displayString.
					].
		html space.
		html spanNamed: 'sel' with: 'Value selected= ' , selection displayString.
		].
! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/14/2006 23:05'!
renderProvincesOn: html

	html spanNamed: 'provinceSelector' with:
		[html
			selectFromList:  self provinceNames
			selected: province
			callback: [:f | province := f] 
			labels: [:ea |  ea ]
			liveCallback: 
				[:anObject :h | 
				province := anObject. 
				city := self cityNames first.
				self renderCitiesOn: h]].
	self renderCitiesOn: html.


! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/3/2006 17:07'!
renderRadioOn: html
	html
		form: [
			html table: [
				html tableRow: [
					html tableData: 'Language'.
					html tableData: 'Yes'.
					html tableData: 'No'].

				booleans associationsDo:
					[:assoc | 
					| group |
					html tableRow: [
						group := html radioGroup.
						html tableData: assoc key.
						html tableData: [
							html cssId: assoc key asString , '-on'.
							html
								radioButtonInGroup: group
								selected: assoc value
								callback: [assoc value: true]
								liveCallback:
									[:item :h |
									assoc value: true.
									h spanNamed: 'radio' with: booleans printString]].
						html tableData: [
							html cssId: assoc key asString , '-off'.
							html
								radioButtonInGroup: group
								selected: assoc value not
								callback: [assoc value: false]
								liveCallback:
									[:item :h |
									assoc value: false.
									h spanNamed: 'radio' with: booleans printString]].
					]].
			]]! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 4/11/2006 07:52'!
renderStyle: aString on: html
	| color |
	color := aString ifNil: ['red'].
	html attributes id: 'style-1'.
	html tag: 'style' do:'#sel {color:' , color , ';}'.
	html attributes id: 'style-2'.
	html tag: 'style' do: '#selection {color:' , color , ';}'.
! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/15/2006 09:32'!
renderUnproductiveOn: html
	
	html form:
		[html break.
		html text: 'Unproductive callback, i.e. no contribution to the page'.
		html break.
		html checkboxWithValue: bool 
				callback: [:v | bool := v ] 
				liveCallback: 
					[:item :h |
					bool := item.
					h span id: 'unused-id'; with: 'This should not be shown'.
					].
		].
! !

!WALiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/4/2006 10:26'!
rendererClass
	"Intentionally using the classic API"
	^WAAsyncHtmlRenderer! !

WAAsyncComponent subclass: #WAPeriodicLiveRequestTest
	instanceVariableNames: 'log'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Tests'!

!WAPeriodicLiveRequestTest classSide methodsFor: 'class initialization' stamp: 'mb 11/3/2006 18:25'!
initialize
	self registerAsApplication: 'tests/async/classic/periodictests'! !

!WAPeriodicLiveRequestTest methodsFor: 'initialize' stamp: 'mb 3/16/2006 08:40'!
initialize
	log _ String new writeStream.
! !

!WAPeriodicLiveRequestTest methodsFor: 'rendering' stamp: 'mb 3/30/2006 19:05'!
renderContentOn: html

	self renderRefreshedElementsOn: html.
	self renderRefreshedLogOn: html.
! !

!WAPeriodicLiveRequestTest methodsFor: 'rendering' stamp: 'mb 3/30/2006 19:08'!
renderLogOn: html
	html withLineBreaks: log contents
			
! !

!WAPeriodicLiveRequestTest methodsFor: 'rendering' stamp: 'mb 4/7/2006 19:36'!
renderRefreshedElementsOn: html

	| liveUpdateBlock |
	liveUpdateBlock _ [ :event :h |
		log nextPutAll:
				'Timed log at ' 
				, Time now printString 
				, ' for ' , event elementId;
			cr; 
			nextPut: Character lf.
		h text: Time now printString].
	
	html table: [
		html
			tableRowWith: [html text: 'Current Time in default div:']
				with: 
					[log nextPutAll: 'Default div id=' , html peekNextId; cr; nextPut: Character lf.
					html refreshDivWith: liveUpdateBlock every: 2 seconds];
			tableRowWith: [html text: 'Current Time in named div:']
				with: 
					[log nextPutAll: 'Named div id=myLiveDiv'; cr; nextPut: Character lf.
					html refreshDivNamed: 'myLiveDiv' with: liveUpdateBlock every: 3 seconds];
			tableRowWith: [html text: 'Current Time in default span:']
				with:
					[log nextPutAll: 'Default span id=' , html peekNextId; cr; nextPut: Character lf.
					html refreshSpanWith: liveUpdateBlock every: 5 seconds].
		].
! !

!WAPeriodicLiveRequestTest methodsFor: 'rendering' stamp: 'mb 3/30/2006 19:09'!
renderRefreshedLogOn: html
	html heading: 'Refreshed log' level: 3.
	html
		divNamed: 'log'
		with: [self renderLogOn: html]
		refreshWith:
			[ :event :h | 
			h break.
			self renderLogOn: h]
	 	every: 5 seconds 
			
! !

!WAPeriodicLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/4/2006 10:26'!
rendererClass
	"Intentionally using the classic API"
	^WAAsyncHtmlRenderer! !

!WATagBrush methodsFor: '*seasideasync' stamp: 'mb 11/3/2006 19:20'!
forEvent: aString callback: callback 
	| uri |
	callback fixCallbackTemps.
	uri := canvas urlForLiveAction: [:event :renderer |
		callback numArgs = 0 ifTrue: [callback value].
		callback numArgs = 1 ifTrue: [callback value: event].
		callback value: event value: renderer].
	self attributes at: aString put: 
			'liveEventTrackerUri(event,' 
			, (canvas encode: uri asString) printString 
			, ')'! !

!WATagBrush methodsFor: '*seasideasync' stamp: 'mb 3/31/2006 08:54'!
onClickCallback: aBlock
	self forEvent: 'onclick' callback: aBlock ! !

!WATagBrush methodsFor: '*seasideasync' stamp: 'mb 3/31/2006 08:54'!
onFocusCallback: aBlock
	self forEvent: 'onfocus' callback: aBlock ! !

!WATagBrush methodsFor: '*seasideasync' stamp: 'mb 11/3/2006 17:22'!
refreshWith: liveBlock every: aDuration
	" I refresh myself every aDuration with aBlock.
	No overlapping executions will take place, the next refresh is only scheduled after the block finished executing "
	| uri id |
	id := self ensureId.
	liveBlock fixCallbackTemps.
	uri := canvas urlForLiveAction:
			[ :event :renderer |
			(renderer tag: self tag)
				id: id; 
				with: [liveBlock value: event value: renderer].].
	self session
		addLoadScript: 
			'timedUpdate('
				, (canvas encode: uri asString) printString
				, ', ' 
				, aDuration asMilliSeconds printString
				, ')'
! !

Object subclass: #WALiveEvent
	instanceVariableNames: 'type when elementTagName elementId elementValue elementType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Rendering'!

!WALiveEvent classSide methodsFor: 'as yet unclassified' stamp: 'mb 3/30/2006 16:46'!
initialize
	(self respondsTo: #convertSeasideString:)
		ifFalse:
			[self error: 'This version of SeasideAsync requires Seaside 2.6b1 or better'].! !

!WALiveEvent classSide methodsFor: 'as yet unclassified' stamp: 'mb 3/30/2006 13:26'!
newFromRequest: aRequest
	^self new fromRequest: aRequest! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:54'!
elementId
	^ elementId! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:54'!
elementId: id
	^ elementId := id! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:53'!
elementTagName
	^ elementTagName! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:54'!
elementType
	^ elementType! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:54'!
elementValue
	^ elementValue! !

!WALiveEvent methodsFor: 'initialization' stamp: 'mb 11/14/2006 22:52'!
fromRequest: aRequest
	aRequest isLiveRequest ifFalse: [^self error: 'Not a live request'].
	when := aRequest at: 'timestamp'.

	(aRequest includesKey: 's') ifTrue:
		"Live callback"
		[elementValue := aRequest at: 's'].
	(aRequest includesKey: 'eventType') ifTrue:
		"Event tracking"
		[type := aRequest at: 'eventType'.
		elementType := aRequest at: 'targetType'.
		elementTagName := aRequest at: 'tagName'.
		elementId := aRequest at: 'id'.
		elementValue := aRequest at: 'targetValue'].
	
! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:54'!
type
	^ type! !

!WALiveEvent methodsFor: 'services' stamp: 'mb 3/30/2006 16:29'!
value
	type = 'check' ifTrue: [^self valueAsBoolean].
	^elementValue.! !

!WALiveEvent methodsFor: 'services' stamp: 'mb 3/30/2006 16:29'!
valueAsBoolean
	^elementValue = 'true'! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:54'!
when
	^ when! !

PackageInfo subclass: #SeasideAsyncVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Platform'!

!SeasideAsyncVWInfo classSide methodsFor: 'file-out' stamp: 'mb 11/18/2005 09:05'!
fileOutVW5
	VW5PackageExporter
		fileOutPackage: self default 
		on: (FileStream forceNewFileNamed: 'SeasideAsyncVW5.st')! !

!SeasideAsyncVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 11/18/2005 13:55'!
externalName
	^ 'SeasideAsync'! !

!SeasideAsyncVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 11/18/2005 09:06'!
ignoredCategories
	^ #('Platform' )! !

!SeasideAsyncVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 11/18/2005 09:10'!
includesSystemCategory: aString
	^ (aString beginsWith: 'SeasideAsync-')
	 and: [(self ignoredCategories includes: (aString copyAfter: $-)) not]! !

!SeasideAsyncVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 11/18/2005 13:48'!
isYourClassExtension: aString
	^ (self category: aString asLowercase matches: '*seasideasync')
		and: [(aString endsWith: 'squeak') not]! !

!SeasideAsyncVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 5/30/2006 16:40'!
name
	^ 'SeasideAsync'! !

!SeasideAsyncVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 1/13/2006 16:21'!
namespace
	^ 'Seaside'! !

!SeasideAsyncVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 11/18/2005 09:08'!
needsNamespace
	^false! !

!SeasideAsyncVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 11/18/2005 09:09'!
packageName
	^ 'SeasideAsyncVW'! !

!SeasideAsyncVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 5/30/2006 16:40'!
versionString
	| ancestor |
	ancestor _ (MCPackage named: self name) workingCopy ancestry ancestors first.
	^ancestor name , '.mcz      ' , ancestor date printString, ' ', ancestor time printString ! !

!WAAnchorTag methodsFor: '*seasideasync' stamp: 'mb 11/3/2006 17:20'!
liveCallback: liveBlock
	| uri id |
	id := self ensureId.
	liveBlock fixCallbackTemps.
	uri := canvas urlForLiveAction: [:event :h | liveBlock value: h].
	self session 
		addLoadScript: 
			'document.getElementById('
				, id asString printString
				, ').onclick = liveClick(' 
				, id asString printString
				, ','
				, (canvas encode: uri asString) printString
				, ')'
! !

Browser subclass: #WAPermissiveBrowser
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

!WAPermissiveBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 19:59'!
component
	^ component! !

!WAPermissiveBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 19:59'!
component: anObject
	component := anObject! !

!WAPermissiveBrowser methodsFor: 'confirm' stamp: 'mb 10/13/2006 18:48'!
confirm: aString
	^self component confirm: aString! !

!WAPermissiveBrowser methodsFor: 'confirm' stamp: 'mb 10/18/2006 15:36'!
confirmRemovalOf: aSelector on: aClass
	^1! !

!WAPermissiveBrowser methodsFor: 'confirm' stamp: 'mb 10/18/2006 14:37'!
request: aString initialAnswer: anotherString
	^self component request: aString default: anotherString! !

!WAPermissiveBrowser methodsFor: 'accessing' stamp: 'mb 10/18/2006 15:35'!
systemNavigation
	! !

WAHtmlRoot subclass: #WAXmlRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Rendering'!

!WAXmlRoot methodsFor: 'constants' stamp: 'mb 3/30/2006 13:06'!
contentType
	^'text/xml'! !

!WAXmlRoot methodsFor: 'constants' stamp: 'mb 11/14/2006 23:46'!
writeOn: aStream
	aStream 
		nextPutAll: '<?xml version="1.0" encoding="';
		nextPutAll: self charSet;
		nextPutAll: '"?><body'.
	bodyAttrs writeOn: aStream.
	aStream nextPutAll: '>'.! !

Error subclass: #WAUnknownVariable
	instanceVariableNames: 'varName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

!WAUnknownVariable methodsFor: 'accessing' stamp: 'mb 10/18/2006 15:18'!
messageText
	"Return an exception's message text."

	^'Undefined variable ' , varName printString! !

!WAUnknownVariable methodsFor: 'accessing' stamp: 'mb 10/18/2006 15:12'!
varName
	"Answer the value of varName"

	^ varName! !

!WAUnknownVariable methodsFor: 'accessing' stamp: 'mb 10/18/2006 15:12'!
varName: anObject
	"Set the value of varName"

	varName _ anObject! !

!WARadioButtonTag methodsFor: '*seasideasync' stamp: 'mb 11/3/2006 18:58'!
liveCallback: liveBlock
	| uri id |
	id := self ensureId.
	liveBlock fixCallbackTemps.
	uri := canvas urlForLiveAction: 
		[:event :h | liveBlock 
			value: event valueAsBoolean
			value: h].
	self session 
		addLoadScript: 
			'document.getElementById('
				, id asString printString
				, ').onclick = liveCheck(' 
				, id asString printString
				, ','
				, (canvas encode: uri asString) printString
				, ')'
! !

WAHtmlRenderer subclass: #WAAsyncHtmlRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Renderers'!

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:06'!
anchorWithAction: actionBlock liveAction: liveBlock do: aString
	| uri id |
	id := self ensureId.
	self anchorWithAction: actionBlock do: aString.
	liveBlock fixCallbackTemps.
	uri := self urlForLiveAction: [:event :h | liveBlock value: h].
	self 
		script: 'document.getElementById('
				, id asString printString
				, ').onclick = liveUpdaterUri('
				, (self class encode: uri asString) printString
				, ')'! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:06'!
anchorWithAction: actionBlock liveAction: liveBlock text: aString
	self anchorWithAction: actionBlock liveAction: liveBlock do: aString.! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:05'!
checkboxWithValue: aBoolean callback: callbackBlock liveCallback: liveBlock 
	| uri id |
	id := self ensureId.
	self checkboxWithValue: aBoolean callback: callbackBlock.
	liveBlock fixCallbackTemps.
	uri := self urlForLiveAction:
		[:event :h | liveBlock
			value: event valueAsBoolean
			value: h].
	self 
		script: 'document.getElementById(' 
				, id asString printString 
				, ').onclick = liveCheck(' 
				, id asString printString 
				, ',' 
				, (self class encode: uri asString) printString 
				, ')'! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:06'!
dateInputWithValue: aDate callback: aBlock liveCallback: liveBlock
	| day month year |
	aBlock fixCallbackTemps.
	
	day _ aDate dayOfMonth.
	month _ aDate monthIndex.
	year _ aDate year.
	self
		selectFromList: (1 to: 12)
		selected: month
		callback: [:v | month _ v]
		labels: [:ea | Date nameOfMonth: ea]
		liveCallback:
			[:v :h |
			month _ v.
			liveBlock
				value: (self
							makeDateWithDay: day 
							monthNumber: month 
							year: year)
				value: h].
	self space.
	(self attributes)
			at: 'size' put: 2;
			at: 'maxlength' put: 2.			
	self
		textInputWithValue: day 
		callback: [:v | day _ v]
		liveCallback:
			[:v :h |
			day _ v.
			liveBlock
				value: (self
							makeDateWithDay: day 
							monthNumber: month 
							year: year)
				value: h].
	self space.
	(self attributes)
			at: 'size' put: 4;
			at: 'maxlength' put: 4.			
	self 
		textInputWithValue: year
		callback: [:v | year _ v]
		liveCallback:
			[:v :h |
			year _ v.
			liveBlock
				value: (self
							makeDateWithDay: day 
							monthNumber: month 
							year: year)
				value: h].
	self hiddenInputWithCallback:
		[aBlock
			value: (self
						makeDateWithDay: day 
						monthNumber: month 
						year: year)]
! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:07'!
divNamed: divName with: aBlock refreshWith: liveBlock every: aDuration

	self
		refreshElementNamed: divName
		createElementWith: #divNamed:with:
		with: aBlock
		refreshWith: liveBlock
		every: aDuration
! !

!WAAsyncHtmlRenderer methodsFor: 'private' stamp: 'mb 11/3/2006 18:07'!
forEvent: aString callback: callback 
	| uri |
	callback fixCallbackTemps.
	uri := self urlForLiveAction: [:event :renderer |
		callback numArgs = 0 ifTrue: [callback value].
		callback numArgs = 1 ifTrue: [callback value: event].
		callback value: event value: renderer].
	self attributes at: aString put: 
			'liveEventTrackerUri(event,' 
			, (self class encode: uri asString) printString 
			, ')'! !

!WAAsyncHtmlRenderer methodsFor: 'private' stamp: 'mb 11/3/2006 18:07'!
fromStringLiveConverterBlockFor: anObject callback: aBlock
	^ [:event :h |
	| text |
	text := event value. 
	aBlock value: 
		( [anObject convertSeasideString: text] on: Error do: [:e | text ] )
		value: h
	]
! !

!WAAsyncHtmlRenderer methodsFor: 'private' stamp: 'mb 11/3/2006 18:09'!
makeDateWithDay: day monthNumber: month year: year
	^Date
		newDay: (day min: (Date daysInMonth: month forYear: year))
		monthNumber: month
		year: year! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:10'!
onClickCallback: callback 
	self forEvent: 'onclick' callback: callback! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:10'!
onFocusCallback: callback 
	self forEvent: 'onfocus' callback: callback! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:10'!
radioButtonInGroup: radioGroupKey selected: aBoolean callback: callbackBlock liveCallback: liveBlock
	| uri id |
	id := self ensureId.
	self radioButtonInGroup: radioGroupKey selected: aBoolean callback: callbackBlock.
	liveBlock fixCallbackTemps.
	uri := self urlForLiveAction:
		[:event :h | liveBlock
			value: event valueAsBoolean
			value: h].
	self 
		script: 'document.getElementById(' 
				, id asString printString 
				, ').onclick = liveCheck(' 
				, id asString printString 
				, ',' 
				, (self class encode: uri asString) printString 
				, ')'! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:10'!
refreshDivNamed: divName with: liveBlock every: aDuration

	self
		divNamed: divName
		with: []
		refreshWith: liveBlock
		every: aDuration! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:10'!
refreshDivWith: liveBlock every: aDuration
	"Convenience method if you do not want/need to supply
	the css id of the refreshing div"

	self
		refreshDivNamed: self ensureId
		with: liveBlock
		every: aDuration
! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:10'!
refreshElementNamed: elementName createElementWith: aSymbol with: aBlock refreshWith: liveBlock every: aDuration
	"Private method to creates an element using aSymbol that executes and displays the result 
	of liveBlock in intervals of aDuration. The interval starts at the end of execution: 
	if liveBlock is time consuming, the next execution will happen aDuration later.
	No overlapping refreshes will occur.
	See #refreshDivWith:every: and refreshSpanWith:"
	
	| uri |
	self perform: aSymbol
			with: elementName
			with: aBlock.
	liveBlock fixCallbackTemps.
	uri := self urlForLiveAction:
			[ :event :h | 
			event elementId: elementName.
			h perform: aSymbol 
				with: elementName 
				with: [liveBlock value: event value: h]].
	WACurrentSession value addLoadScript:
			'timedUpdate('
				, (self class encode: uri asString) printString
				, ', ' 
				, aDuration asMilliSeconds printString
				, ')'
! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:10'!
refreshSpanNamed: spanName with: liveBlock every: aDuration

	self
		spanNamed: spanName 
		with: [] 
		refreshWith: liveBlock 
		every: aDuration! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:11'!
refreshSpanWith: liveBlock every: aDuration
	"Convenience method if you do not want/need to supply
	the css id of the refreshing span"

	self
		refreshSpanNamed: self ensureId
		with: liveBlock
		every: aDuration
! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:11'!
scrollbarWithHeight: heightNumber size: sizeNumber liveCallback: liveBlock
	| id uri |
	id := self ensureId.
	self attributeAt: 'style' 
		put: 'position: relative; left: -3px; width: 19px; overflow: auto; height: '
			, heightNumber displayString
			, 'px'.
	self div:
		[self attributeAt: 'style' put: 'width: 1px; height: ', sizeNumber displayString, 'px'.
		self div: ''].
	liveBlock fixCallbackTemps.
	uri := self urlForLiveAction:
		[:event :h | liveBlock 
			value: event value asInteger
			value: h].
	self 
		script: 'document.getElementById('
				, id asString printString
				, ').onscroll = liveScroll('
				, id asString printString
				, ', '
				, (self class encode: uri asString) printString
				, ')'! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:11'!
selectFromList: aCollection selected: anObject callback: callbackBlock labels: labelsBlock liveCallback: liveBlock
	| uri id items |
	id := self ensureId.
	items := aCollection asArray.
	self selectFromList: items selected: anObject callback: callbackBlock labels: labelsBlock.
	liveBlock fixCallbackTemps.
	uri := self urlForLiveAction:
			[:event :h | liveBlock 
				value: (items at: event value asInteger + 1 ifAbsent: [])
				value: h].
	self 
		script: 'document.getElementById('
				, id asString printString
				, ').onchange = liveSelect('
				, id asString printString
				, ','
				, (self class encode: uri asString) printString
				, ')'
! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:11'!
selectFromList: aCollection selected: anObject callback: aBlock labels: labelBlock other: otherBlock label: aString
	| id other  |
	id _ 'id', self context advanceKey displayString.
	other _ (self context nextKey asNumber + aCollection size + 1) displayString.
	self attributes onChange: 'if(this.value == ', other printString, ') {document.getElementById(', id printString, ').style.display = "inline"; document.getElementById(', id printString, ').focus()} else {document.getElementById(', id printString, ').style.display = "none"}'.
	self
		selectFromList: (aCollection asArray copyWith: aString)
		selected: anObject
		callback: [:v | v = aString ifFalse: [aBlock value: v]]
		labels: [:ea | ea = aString ifTrue: [aString] ifFalse: [labelBlock value: ea]].
	self space.
	self cssId: id.
	self attributes style: 'display: none'.
	self textInputWithValue: nil callback: [:v | v ifNotNil: [otherBlock value: v]]! !

!WAAsyncHtmlRenderer methodsFor: 'xml' stamp: 'mb 11/4/2006 10:25'!
spaceEntity
	^'&#160;'! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:11'!
spanNamed: spanName with: aBlock refreshWith: liveBlock every: aDuration

	self
		refreshElementNamed: spanName
		createElementWith: #spanNamed:with:
		with: aBlock
		refreshWith: liveBlock
		every: aDuration
! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:11'!
textAreaWithCallback: callbackBlock liveCallback: liveBlock
	self textAreaWithValue: '' callback: callbackBlock liveCallback: liveBlock! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:11'!
textAreaWithValue: value callback: callbackBlock liveCallback: liveBlock
	| uri id liveCallback |
	id := self ensureId.
	self textAreaWithValue: value callback: callbackBlock.
	liveBlock fixCallbackTemps.
	liveCallback := self fromStringLiveConverterBlockFor: value callback: liveBlock.
	uri := self urlForLiveAction: liveCallback.
	self 
		script: 'liveSearch('
				, id asString printString
				, ','
				, (self class encode: uri asString) printString
				, ')'.
	! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:12'!
textInputWithCallback: callbackBlock liveCallback: liveBlock
	self textInputWithValue: '' callback: callbackBlock liveCallback: liveBlock! !

!WAAsyncHtmlRenderer methodsFor: 'public api' stamp: 'mb 11/3/2006 18:12'!
textInputWithValue: value callback: callbackBlock liveCallback: liveBlock
	| uri id liveCallback |
	id := self ensureId.
	self textInputWithValue: value callback: callbackBlock.
	liveBlock fixCallbackTemps.
	liveCallback := self fromStringLiveConverterBlockFor: value callback: liveBlock.
	uri := self urlForLiveAction: liveCallback.
	self 
		script: 'liveSearch('
				, id asString printString
				, ','
				, (self class encode: uri asString) printString
				, ')'.
	! !

!WAAsyncHtmlRenderer methodsFor: 'private' stamp: 'mb 11/3/2006 18:12'!
urlForLiveAction: actionBlock 
	| url |
	url := context actionUrl withParameter: (self callbacks registerLiveActionCallback: actionBlock renderer: self).
	^url asString! !

!WARequest methodsFor: '*SeasideAsync' stamp: 'mb 11/21/2006 14:38'!
isLiveRequest
	^ (self headerAt: 'x-requested-by') = 'SeasideAsync'! !

!WARenderedHtmlRoot methodsFor: '*seasideasync' stamp: 'mb 11/6/2006 11:58'!
scripts
	^scripts! !

WATimeInput subclass: #WALiveTimeInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Renderers'!

!WALiveTimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 17:57'!
addHoursCallbackToBrush: aBrush
	super addHoursCallbackToBrush: aBrush.
	self hasLiveCallback ifFalse: [^self].
	aBrush liveCallback:
		[:h :renderer |
		self hours: h.
		self liveCallback value: self setValueWithNewTime value: renderer].

! !

!WALiveTimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 17:57'!
addMinutesCallbackToBrush: aBrush
	super addMinutesCallbackToBrush: aBrush.
	self hasLiveCallback ifFalse: [^self].
	aBrush liveCallback:
		[:m :renderer |
		self minutes: m.
		self liveCallback value: self setValueWithNewTime value: renderer].



! !

!WALiveTimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 17:57'!
addSecondsCallbackToBrush: aBrush
	super addSecondsCallbackToBrush: aBrush.
	self hasLiveCallback ifFalse: [^self].
	aBrush liveCallback:
		[:s :renderer |
		self seconds: s.
		self liveCallback value: self setValueWithNewTime value: renderer].


! !

WADateInput subclass: #WALiveDateInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Renderers'!

!WALiveDateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:26'!
addDayCallbackToBrush: aBrush
	super addDayCallbackToBrush: aBrush.
	self hasLiveCallback ifFalse: [^self].
	aBrush liveCallback:
		[:d :renderer |
		self day: d.
		self liveCallback value: self setValueWithNewDate value: renderer].


! !

!WALiveDateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:26'!
addMonthCallbackToBrush: aBrush
	super addMonthCallbackToBrush: aBrush.
	self hasLiveCallback ifFalse: [^self].
	aBrush liveCallback:
		[:m :renderer |
		self month: m.
		self liveCallback value: self setValueWithNewDate value: renderer].

! !

!WALiveDateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:26'!
addYearCallbackToBrush: aBrush
	super addYearCallbackToBrush: aBrush.
	self hasLiveCallback ifFalse: [^self].
	aBrush liveCallback:
		[:y :renderer |
		self year: y.
		self liveCallback value: self setValueWithNewDate value: renderer].

! !

!WACompound methodsFor: '*seasideasync' stamp: 'mb 11/3/2006 14:25'!
hasLiveCallback
	^self liveCallback notNil! !

!WACompound methodsFor: '*seasideasync' stamp: 'mb 11/3/2006 10:31'!
liveCallback
	^properties at: #liveCallback ifAbsent: [nil]! !

!WACompound methodsFor: '*seasideasync' stamp: 'mb 11/3/2006 10:31'!
liveCallback: aBlock
	properties at: #liveCallback put: aBlock! !

!WACallbackRegistry methodsFor: '*seasideasync' stamp: 'mb 3/21/2006 14:10'!
registerLiveActionCallback: aBlock renderer: aRenderer
	^self storeCallback: (WALiveActionCallback new
		block: aBlock;
		rendererClass: aRenderer class;
		callbacks: self)! !

!WABrowser class methodsFor: '*seasideAsync' stamp: 'mb 11/6/2006 08:51'!
fullOnClass: aClass selector: aSelector
	"Substitute a more modern browser"
	^WAFullClassBrowser fullOnClass: aClass selector: aSelector! !

!Parser methodsFor: '*seasideAsync-squeak' stamp: 'mb 11/6/2006 08:50'!
interactive

	^ (requestor == nil
		or: [requestor isKindOf: SyntaxError]
			or: [requestor isKindOf: WABrowser]
				or: [requestor isKindOf: WAFullClassBrowser]) not! !

WAActionCallback subclass: #WALiveActionCallback
	instanceVariableNames: 'rendererClass callbacks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Rendering'!

!WALiveActionCallback commentStamp: '<historical>' prior: 0!
This idea is from Radoslav Hodnicak
(rh@4096.sk)

Apparently the way LiveUpdate is built currently(SeasideAsync-mb.23), the 
live callbacks have a different session step (_k) than the rest of the page,
i.e. a new continuation for each live callback. If you generate enough of
them, then the original page gets pushed so far back in the history that
it blows the cache. 

Rado's changes fix this problem by processing live callbacks in the same way
normal callbacks are processed, instead of treating them as separate continuations.

The changes are activated in WAHtmlRenderer and WARenderCanvas by sending
#urlForLiveAction: rather than #urlForLiveRequest: The old behavior can be
restored by sending #urlForLiveRequest: rather than #urlForLiveAction:

!

!WALiveActionCallback methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:24'!
callbacks
	^callbacks! !

!WALiveActionCallback methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:24'!
callbacks: anObject
	callbacks := anObject! !

!WALiveActionCallback methodsFor: 'responding' stamp: 'mb 11/3/2006 17:30'!
evaluateWithArgument: argument 
	| currentSession request response renderer document event |
	currentSession := WACurrentSession value.
	request := currentSession currentRequest.
	event := WALiveEvent newFromRequest: request.
	response := WAResponse new.
	response contentType: 'text/xml; charset=utf-8'.
	renderer := self rendererClass
		context: context copy
		callbacks: self callbacks.
	document := WAXmlStreamDocument new
		stream: response stream.
	renderer context document: document.
	block value: event value: renderer.
	document close.
	currentSession returnResponse: response! !

!WALiveActionCallback methodsFor: 'accessing' stamp: 'mb 3/21/2006 14:21'!
rendererClass
	^rendererClass
! !

!WALiveActionCallback methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:23'!
rendererClass: anObject
	rendererClass := anObject! !

WAScriptLibrary subclass: #WAAsyncScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Libraries'!

!WAAsyncScripts methodsFor: 'scripts' stamp: 'mb 11/21/2006 14:42'!
ajax
	^ '

var requests = [];

function liveUpdater(uriFunc, ret)
{
	function xmlUpdater()
	{
		return sendHttpCallback(uriFunc(), ret);
	}
	return xmlUpdater;

	//	Build and send HTTP request to Seaside

	function sendHttpCallback(uri, ret, respFunc)
	{
		var request = newHttpRequest();
		if (!!request)
			return ret;
		if (!!respFunc)
			respFunc = processRequestChange;
		request.onreadystatechange = respFunc;
		// Resolve xml entity before issuing the request
		var uri = addParameter(uri, "timestamp", (new Date()).getTime().toString());
		var regex = new RegExp("&amp;", "g");
		uri = uri.replace(regex,"&");
		request.open("GET", uri, true);
		setRequestHeaders(request);
		request.send(null);
		requests[requests.length] = request;
// debug("GET " + uri);
// debug ("Pending " + requests.length);
		return ret;
	}

	//	Process state change of HTTP requests

	function processRequestChange()
	{
		var pendingRequests = [];
		for ( var rx = 1 ; rx <= requests.length ; rx++ ) {
			var request = requests[rx-1];
			if (request.readyState == 4) {
				handleLiveResponse(request);
			} else {
				pendingRequests[pendingRequests.length] = request;
			}
		}
		if (requests.length !!= pendingRequests.length) {
			requests = pendingRequests
// debug ("Pending " + requests.length);
		}
	}

	//	Parse HTTP response from the Seaside live callbacks as XML and update the document

	function handleLiveResponse(request)
	{	
		var doc = request.responseXML;
		var replacements = [];
		var anyReplacement = false;
		var anyScriptEvaluated = false;
// debug("HTTP status " + request.status + " " + request.statusText);
// debug(request.responseText);			
// debug(request.getAllResponseHeaders() );	
		if (doc !!= null) {
			var elements = doc.getElementsByTagName("*");
			if (elements.length == 0) {
				// IE does not support the above, use an alternative hard-coded technique
				elements = getAllElements(doc)
			}
			// Find html elements with the id= attribute
			for ( var x = 1 ; x <= elements.length ; x++ ) {
				var elem = elements[x-1];
				if (elem.tagName == "body") {
					var body = xmlString(elem);
				}
				var attributes = elem.attributes;
				if (attributes.length > 0) {
					for ( var ax = 1 ; ax <= attributes.length ; ax++ ) {
						var attr = attributes[ax-1];
						var attrName = attr.name;
						if (attrName == "id") {
							// Find the html element in the document that has a matching id and replace it
							var docElement = document.getElementById(attr.value);
							if (docElement) {
								if (!!includes(replacements,elem)) {
									// HTML is only updated with the parent at highest level
									// Resolve IE and Opera issue where <br></br> skips two lines
									var regex = new RegExp("<br></br>", "g");
									var replacement = xmlString(elem).replace(regex,"<br/>");
									try {
										docElement.innerHTML = replacement;
										anyReplacement = true;
										replacements[replacements.length] = attr.value;
									} catch (e) {
										// Some browsers (like Safari) have read-only elements
										// IE does not allow form elements for innerHTML
									}
								}
							}
						}
					}
				}   
			}
			// Find html <script> elements and execute them
			for ( var x = 1 ; x <= elements.length ; x++ ) {
				var elem = elements[x-1];
				if (elem.tagName == ''script'') {
					eval(elem.childNodes[0].data);
					anyScriptEvaluated = true;
				}
			}
		}
		if (!!anyReplacement & !!anyScriptEvaluated) {
			if ( body ) {
				// Here when XML could be parsed but was unproductive
				// Most probable reason : a bug in the live callback code
				alert("No replacement and no script evaluated, probable bug in your callback code.\n\n"
					+ "See below the response produced by the callback code.\n\n"
					+ request.responseText);
				// document.body.innerHTML = body;
			} else {
				// Here when XML could not be parsed
				// Most probable reason : response does not have an xml content
				// For instance : an exception in the live callback
				// So we replace the whole page with the whole response
				try {
					if (!!request.responseText.length == 0) {
						document.body.innerHTML = request.responseText;
					} else {
						debug("HTTP code " + request.status + " " + request.statusText
									+ " with no text in response!!");
					}	
				} catch (e) {
					// In some cases of concurrency
					// readyState is 4, but there status is not available
					debug("HTTP response status not available although readyState is 4!!");
					debug(request.responseText);	
				}					
			}
		}
	}
}
'! !

!WAAsyncScripts methodsFor: 'scripts' stamp: 'mb 11/21/2006 14:49'!
eventTracking
	^ '
function liveEventTrackerUri(event, uri)
{
	var target = (event.target) ? event.target : event.srcElement;
	var type = target.type;
	var value = target.value;
	if (type == "radio") value = target.checked;
	if (type == "checkbox") value = (value == "on");
	uri = addParameter(uri, "timestamp", (new Date()).getTime().toString());
	uri = addParameter(uri, "eventType", event.type);
	uri = addParameter(uri, "targetValue", value);
	uri = addParameter(uri, "targetType", type);
	uri = addParameter(uri, "tagName", target.tagName);
	uri = addParameter(uri, "id", target.id);
//	Cursor position ?
	var request = newHttpRequest();
	if (!!request) return false;
	request.onreadystatechange = processEventTracker;
	// Resolve xml entity before issuing the request
	var regex = new RegExp("&amp;", "g");
	uri = uri.replace(regex,"&");
	request.open("GET", uri, true);
	setRequestHeaders(request);
	request.send(null);
	return false;

	function processEventTracker()
	{
	// Response from the event tracking callback is empty
// alert( request.responseText);
// alert( request.status);
// alert( request.statusText);
// alert( request.getAllResponseHeaders() );	
// alert( request.responseXML.parseError.errorCode);
// alert( request.responseXML.parseError.reason);
	}

}
'! !

!WAAsyncScripts methodsFor: 'scripts' stamp: 'mb 11/3/2006 18:16'!
liveUpdate
	^ '

	var nav;
	if (navigator.userAgent.indexOf("Safari") > 0)
			nav = "Safari";
	else if (navigator.product == "Gecko")
			nav = "Gecko";
	else
			nav = "IE";

function liveUpdaterUri(uri)
{
	return liveUpdater(function() { return uri; } , false);
}

// Selection in a list box, add the selected index to the callback
function liveSelect(id, uri)
{
	function constructUri()
	{
		return addParameter(uri, "s", document.getElementById(id).selectedIndex.toString());
	}
	return liveUpdater(constructUri, false);
}

// Key stroke in an entry field, add the field value to the callback
function liveSearch(id, uri)
{
	function constructUri()
	{
		return addParameter(uri, "s", document.getElementById(id).value);
	}

   	var updater = liveUpdater(constructUri, false);
	var last = document.getElementById(id).value;
	var timeout = false;
  
	function update()
	{
		if (last !!= document.getElementById(id).value) {
			last = document.getElementById(id).value;
			updater();
		}
	}
	   
	function start() {
		if (timeout)
			window.clearTimeout(timeout);
		timeout = window.setTimeout(update, 300);
	}

	if (navigator.userAgent.indexOf("Safari") > 0)
		document.getElementById(id).addEventListener("keydown",start,false);
	else if (navigator.product == "Gecko")
		document.getElementById(id).addEventListener("keypress",start,false);
	else
		document.getElementById(id).attachEvent("onkeydown",start);
}

// Click
function liveClick(id, uri)
{
	return liveUpdaterUri(uri);
}

// Click in a checkbox
function liveCheck(id, uri)
{
	function constructUri()
	{
		return addParameter(uri, "s", document.getElementById(id).checked);
	}
	return liveUpdater(constructUri);
}

function liveScroll(id, uri)
{
   function constructUri()
   {
         return addParameter(uri, "s", document.getElementById(id).scrollTop.toString());
   }
   
   var updater = liveUpdater(constructUri, false);
   var timeout = false;

    function start() {
	   if (timeout)
	       window.clearTimeout(timeout);
	   
    	   timeout = window.setTimeout(updater, 100);
    }
   return start;
}

function timedUpdate(uri, milliSeconds)
{
	var updater = liveUpdaterUri(uri, false);
	updater();
	var again = "timedUpdate(\""+uri+"\","+milliSeconds+")";
	setTimeout(again, milliSeconds);
}
'! !

!WAAsyncScripts methodsFor: 'scripts' stamp: 'mb 11/21/2006 14:42'!
liveUpdateUtilities
	^'
function addParameter(uri, key, value)
{
	// See http://xkr.us/articles/javascript/encode-compare/
	var separator = "?";
	if (uri.indexOf("?") >= 0)
		separator = "&";
	return uri + separator + key + "=" + encodeURIComponent(value);
}

// Function below to instantiate an XMLHttpRequest object
// Credits: http://jibbering.com/2002/4/httprequest.html
// Credits: http://www.toutjavascript.com/savoir/xmlhttprequest.php3
function newHttpRequest()
{
	var httpRequest = false;
	if(window.XMLHttpRequest)
		// Firefox, Mozilla, Safari
		httpRequest = new XMLHttpRequest();
	else if(window.ActiveXObject) 
		// Internet Explorer
		{	try {  
 				httpRequest = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (e) {
  				try {
   					httpRequest = new ActiveXObject("Msxml2.XMLHTTP");
				} catch (E) {
					httpRequest = false;
 	 			}
			}
		}
	return httpRequest;
}

function setRequestHeaders(request)
{
	request.setRequestHeader("X-Requested-With","XMLHttpRequest");
	request.setRequestHeader("X-Requested-By","SeasideAsync");
	request.setRequestHeader("Accept","text/html, application/xml, text/xml, */*");
}

// Functions below to rebuild the xml string of an element
function xmlString (element) {
	var xml = "";
	for ( var x = 1 ; x <= element.childNodes.length ;  x++ ) {
		var node = element.childNodes[x-1];
		xml += outerXmlString(node);
	}
	return xml;
}
function outerXmlString (element) {
	if (!!element.tagName)
		return element.data;
	var xml = "<" + element.tagName;
	for ( var x = 1 ; x <= element.attributes.length ;  x++ ) {
		var attr = element.attributes[x-1];
		xml += " " + attr.name + "=" + ''"'' + attr.value + ''"'';
	}
	xml += ">";
	for ( var x = 1 ; x <= element.childNodes.length ;  x++ ) {
		var node = element.childNodes[x-1];
		xml += outerXmlString(node);
	}
	xml += "</" + element.tagName + ">";
	return xml;
}

// Function below to get stable equivalent of document.getElementsByTagName("*")
// Credits: http://www.siteexperts.com/tips/contents/ts16/page3.asp
function getAllElements(document)
{
	var elements = [];
	getElements(elements,document.childNodes[0])
	return elements;   
}

// Function below to recursively and deeply collect all sub-elements of an element
// Credits: http://www.siteexperts.com/tips/contents/ts16/page3.asp
function getElements(collection, element) {
	if (element == null) return;
	for ( var x = 1 ; x <= element.childNodes.length ; x++ ) {
		var node = element.childNodes[x-1];
		if (node.nodeType == 1) {
			collection[collection.length] = node[x-1];
				getElements(collection,element);
		}
	}
}

// Function below to detect if the id of any parent of an element is part of an array
function includes(collection, element) {
	var parent = element.parentNode;
	while (parent.tagName) {
		var attributes = parent.attributes;
		if (attributes.length > 0) {
			for ( var ax = 1 ; ax <= attributes.length ; ax++ ) {
				var attr = attributes[ax-1];
				var attrName = attr.name;
				if (attrName == "id") {
					for ( var x = 1 ; x <= collection.length ; x++ ) {
						if (collection[x-1] == attr.value) return true;
					}
				}
			}
		}
		parent = parent.parentNode;
	}
	return false;
}

// Get the text of the body element
function bodyText(doc)
{
	var elements = doc.getElementsByTagName("*");
	if (elements.length == 0) {
		// IE does not support the above, use an alternative hard-coded technique
		elements = getAllElements(doc)
	}
	// Find html elements with the id= attribute
	for ( var x = 1 ; x <= elements.length ; x++ ) {
		var elem = elements[x-1];
		if (elem.tagName == "BODY") {
			var body = xmlString(elem);
		}
	}
	return body;	
}

function debug(aString)
{
	var newDiv = document.createElement("div");
	newDiv.setAttribute("style","position: relative; top: -1.5em; "
		+ "font-size: 60%; font-family: Verdana; color: blue; "
		+ "width: 100%; background-color: lightyellow");
	var textNode = document.createTextNode(aString);
	newDiv.appendChild(textNode);
	document.body.appendChild(newDiv);
}

'! !
WAAutoCompleteTest initialize!
WACanvasFocusTest initialize!
WACanvasLiveRequestTest initialize!
WACanvasPeriodicLiveRequestTest initialize!
WAFocusTest initialize!
WAFullClassBrowser initialize!
WALiveRequestTest initialize!
WAPeriodicLiveRequestTest initialize!
WALiveEvent initialize!
